﻿
Imports VaxTeleServerCOMLib
Imports System.Runtime.InteropServices

Public Class cVaxServerCOM

    Public Const VAX_PEER_TYPE_USER As Integer = 3001
    Public Const VAX_PEER_TYPE_LINE As Integer = 3002
    Public Const VAX_PEER_TYPE_DIRECT_PROXY As Integer = 3003

    Public Const TYPE_VOICE_NORMAL As Integer = 100
    Public Const TYPE_VOICE_USER As Integer = 101
    Public Const TYPE_VOICE_ADMIN As Integer = 102

    Public Const DTMF_TYPE_RFC2833 As Integer = 0
    Public Const DTMF_TYPE_INBAND As Integer = 1
    Public Const DTMF_TYPE_INFO As Integer = 2

    Public Const VAX_CLOSED_REASON_CODE_HANGUP As Integer = 2001
    Public Const VAX_CLOSED_REASON_CODE_SESSION_LOST As Integer = 2002
    Public Const VAX_CLOSED_REASON_CODE_MERGED As Integer = 2003
    Public Const VAX_CLOSED_REASON_CODE_TRANSFERED As Integer = 2004
    Public Const VAX_CLOSED_REASON_CODE_REJECTED As Integer = 2005
    Public Const VAX_CLOSED_REASON_CODE_FAILED As Integer = 2006
    Public Const VAX_CLOSED_REASON_CODE_CANCELLED As Integer = 2007
    Public Const VAX_CLOSED_REASON_CODE_TIMEOUT As Integer = 2008
    Public Const VAX_CLOSED_REASON_CODE_CLOSED As Integer = 2009

    Public Const VAX_CALL_CHANNEL_ZERO As Integer = 0
    Public Const VAX_CALL_CHANNEL_ONE As Integer = 1

    Public Const PLAY_WAVE_MODE_EXCLUSIVE As Integer = 0
    Public Const PLAY_WAVE_MODE_MIXED As Integer = 1

    Public Const VAX_CUSTOM_HEADER_REQ_ID_INVITE As Integer = 0

    Public Const VAX_TRANSFER_TYPE_BLIND As Integer = 401
    Public Const VAX_TRANSFER_TYPE_CONSULT As Integer = 402

    Public Const VAX_CODEC_GSM610 As Integer = 0
    Public Const VAX_CODEC_ILBC As Integer = 1
    Public Const VAX_CODEC_G711A As Integer = 2
    Public Const VAX_CODEC_G711U As Integer = 3
    Public Const VAX_CODEC_G729 As Integer = 4

    Public Const VAX_QUEUE_ALGO_HUNT_RANDOM = 0
    Public Const VAX_QUEUE_ALGO_FEWEST_ANSWERED = 1
    Public Const VAX_QUEUE_ALGO_LEAST_TALK_TIME = 2
    Public Const VAX_QUEUE_ALGO_LONGEST_WAIT_TIME = 3
    Public Const VAX_QUEUE_ALGO_PRIORITIZED_HUNT = 4
    Public Const VAX_QUEUE_ALGO_ROUND_ROBIN = 5

    Public Const VAX_QUEUE_MODE_TYPE_FREE = 0
    Public Const VAX_QUEUE_MODE_TYPE_ANY = 1

    Public Const VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC = 0
    Public Const VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_RING = 1

    Public Const VAX_QUEUE_AGENT_AVAILABLE_STATUS = 0
    Public Const VAX_QUEUE_AGENT_UNAVAILABLE_STATUS = 1

    Public Const VAX_RING_GROUP_ALGO_RING_ALL = 0
    Public Const VAX_RING_GROUP_ALGO_HUNT_RANDOM = 1
    Public Const VAX_RING_GROUP_ALGO_ROUND_ROBIN = 2
    Public Const VAX_RING_GROUP_ALGO_LEAST_ANSWERED = 3
    Public Const VAX_RING_GROUP_ALGO_LEAST_TALK_TIME = 4
    Public Const VAX_RING_GROUP_ALGO_LONGEST_WAITING = 5
    Public Const VAX_RING_GROUP_ALGO_PRIORITIZED_HUNT = 6

    Public Const VAX_RING_GROUP_MODE_FREE = 0
    Public Const VAX_RING_GROUP_MODE_ANY = 1

    Private m_objVaxServerSIP As VaxServerSIP = New VaxServerSIP

    Public Sub New()

        AddHandler m_objVaxServerSIP.OnLineRegisterTrying, AddressOf OnLineRegisterTrying
        AddHandler m_objVaxServerSIP.OnLineRegisterFailed, AddressOf OnLineRegisterFailed
        AddHandler m_objVaxServerSIP.OnLineRegisterSuccess, AddressOf OnLineRegisterSuccess

        AddHandler m_objVaxServerSIP.OnLineUnRegisterTrying, AddressOf OnLineUnRegisterTrying
        AddHandler m_objVaxServerSIP.OnLineUnRegisterFailed, AddressOf OnLineUnRegisterFailed
        AddHandler m_objVaxServerSIP.OnLineUnRegisterSuccess, AddressOf OnLineUnRegisterSuccess

        AddHandler m_objVaxServerSIP.OnUnRegisterUser, AddressOf OnUnRegisterUser
        AddHandler m_objVaxServerSIP.OnRegisterUser, AddressOf OnRegisterUser
        AddHandler m_objVaxServerSIP.OnRegisterUserSuccess, AddressOf OnRegisterUserSuccess
        AddHandler m_objVaxServerSIP.OnRegisterUserFailed, AddressOf OnRegisterUserFailed

        AddHandler m_objVaxServerSIP.OnIncomingCall, AddressOf OnIncomingCall
        AddHandler m_objVaxServerSIP.OnCallSessionConnecting, AddressOf OnCallSessionConnecting
        AddHandler m_objVaxServerSIP.OnCallSessionFailed, AddressOf OnCallSessionFailed
        AddHandler m_objVaxServerSIP.OnCallSessionConnected, AddressOf OnCallSessionConnected
        AddHandler m_objVaxServerSIP.OnCallSessionClosed, AddressOf OnCallSessionClosed

        AddHandler m_objVaxServerSIP.OnCallSessionLost, AddressOf OnCallSessionLost
        AddHandler m_objVaxServerSIP.OnCallSessionHangup, AddressOf OnCallSessionHangup
        AddHandler m_objVaxServerSIP.OnCallSessionTimeout, AddressOf OnCallSessionTimeout
        AddHandler m_objVaxServerSIP.OnCallSessionCancelled, AddressOf OnCallSessionCancelled

        AddHandler m_objVaxServerSIP.OnCallSessionOnHold, AddressOf OnCallSessionOnHold
        AddHandler m_objVaxServerSIP.OnCallSessionOffHold, AddressOf OnCallSessionOffHold

        AddHandler m_objVaxServerSIP.OnCallSessionTransferBlind, AddressOf OnCallSessionTransferBlind
        AddHandler m_objVaxServerSIP.OnCallSessionTransferConsult, AddressOf OnCallSessionTransferConsult

        AddHandler m_objVaxServerSIP.OnCallSessionTransfering, AddressOf OnCallSessionTransfering
        AddHandler m_objVaxServerSIP.OnCallSessionTransferFailed, AddressOf OnCallSessionTransferFailed
        AddHandler m_objVaxServerSIP.OnCallSessionTransferTimeout, AddressOf OnCallSessionTransferTimeout
        AddHandler m_objVaxServerSIP.OnCallSessionTransfered, AddressOf OnCallSessionTransfered

        AddHandler m_objVaxServerSIP.OnChatMessageText, AddressOf OnChatMessageText
        AddHandler m_objVaxServerSIP.OnChatMessageTyping, AddressOf OnChatMessageTyping
        AddHandler m_objVaxServerSIP.OnChatStatusSubscribe, AddressOf OnChatStatusSubscribe

        AddHandler m_objVaxServerSIP.OnChatStatusSendSubscribeSuccess, AddressOf OnChatStatusSendSubscribeSuccess
        AddHandler m_objVaxServerSIP.OnChatStatusSendSubscribeFailed, AddressOf OnChatStatusSendSubscribeFailed

        AddHandler m_objVaxServerSIP.OnChatMessageSuccess, AddressOf OnChatMessageSuccess
        AddHandler m_objVaxServerSIP.OnChatMessageFailed, AddressOf OnChatMessageFailed
        AddHandler m_objVaxServerSIP.OnChatMessageTimeout, AddressOf OnChatMessageTimeout

        AddHandler m_objVaxServerSIP.OnDetectedDigitDTMF, AddressOf OnDetectedDigitDTMF

        AddHandler m_objVaxServerSIP.OnOutgoingDiagnosticLog, AddressOf OnOutgoingDiagnosticLog
        AddHandler m_objVaxServerSIP.OnIncomingDiagnosticLog, AddressOf OnIncomingDiagnosticLog

        AddHandler m_objVaxServerSIP.OnVaxTeleTick, AddressOf OnVaxTeleTick

        AddHandler m_objVaxServerSIP.OnSendTimeoutVM, AddressOf OnSendTimeoutVM
        AddHandler m_objVaxServerSIP.OnSendSuccessVM, AddressOf OnSendSuccessVM

        AddHandler m_objVaxServerSIP.OnCallSessionDialToneStart, AddressOf OnCallSessionDialToneStart
        AddHandler m_objVaxServerSIP.OnCallSessionDialToneStop, AddressOf OnCallSessionDialToneStop

        AddHandler m_objVaxServerSIP.OnCallSessionPlayWaveDone, AddressOf OnCallSessionPlayWaveDone
        AddHandler m_objVaxServerSIP.OnConferenceRoomPlayWaveDone, AddressOf OnConferenceRoomPlayWaveDone

        AddHandler m_objVaxServerSIP.OnCallSessionCreated, AddressOf OnCallSessionCreated
        AddHandler m_objVaxServerSIP.OnCallSessionDetectedAMD, AddressOf OnCallSessionDetectedAMD

        AddHandler m_objVaxServerSIP.OnCallSessionRecordedPCM, AddressOf OnCallSessionRecordedPCM
        AddHandler m_objVaxServerSIP.OnConferenceRoomRecordedPCM, AddressOf OnConferenceRoomRecordedPCM

        AddHandler m_objVaxServerSIP.OnBusyLampSubscribe, AddressOf OnBusyLampSubscribe
        AddHandler m_objVaxServerSIP.OnBusyLampUnSubscribe, AddressOf OnBusyLampUnSubscribe
        AddHandler m_objVaxServerSIP.OnBusyLampSubscribeSuccess, AddressOf OnBusyLampSubscribeSuccess
        AddHandler m_objVaxServerSIP.OnBusyLampSubscribeFailed, AddressOf OnBusyLampSubscribeFailed

        AddHandler m_objVaxServerSIP.OnVaxErrorLog, AddressOf OnVaxErrorLog

        AddHandler m_objVaxServerSIP.OnSendReqTransferCallTimeout, AddressOf OnSendReqTransferCallTimeout
        AddHandler m_objVaxServerSIP.OnSendReqTransferCallAccepted, AddressOf OnSendReqTransferCallAccepted
        AddHandler m_objVaxServerSIP.OnSendReqTransferCallFailed, AddressOf OnSendReqTransferCallFailed
        AddHandler m_objVaxServerSIP.OnQualityReportPUBLISH, AddressOf OnQualityReportPUBLISH
        AddHandler m_objVaxServerSIP.OnBusyLampSendStatus, AddressOf OnBusyLampSendStatus

        AddHandler m_objVaxServerSIP.OnServerConnectingREC, AddressOf OnServerConnectingREC
        AddHandler m_objVaxServerSIP.OnServerConnectedREC, AddressOf OnServerConnectedREC
        AddHandler m_objVaxServerSIP.OnServerFailedREC, AddressOf OnServerFailedREC
        AddHandler m_objVaxServerSIP.OnServerTimeoutREC, AddressOf OnServerTimeoutREC
        AddHandler m_objVaxServerSIP.OnServerHungupREC, AddressOf OnServerHungupREC

        AddHandler m_objVaxServerSIP.OnQueuePlayWaveStart, AddressOf OnQueuePlayWaveStart
        AddHandler m_objVaxServerSIP.OnQueuePlayWaveStop, AddressOf OnQueuePlayWaveStop

        AddHandler m_objVaxServerSIP.OnQueueAgentConnectStarted, AddressOf OnQueueAgentConnectStarted
        AddHandler m_objVaxServerSIP.OnQueueAgentConnectTrying, AddressOf OnQueueAgentConnectTrying
        AddHandler m_objVaxServerSIP.OnQueueAgentConnectFailed, AddressOf OnQueueAgentConnectFailed
        AddHandler m_objVaxServerSIP.OnQueueAgentConnectTimeout, AddressOf OnQueueAgentConnectTimeout
        AddHandler m_objVaxServerSIP.OnQueueAgentConnectSuccess, AddressOf OnQueueAgentConnectSuccess

        AddHandler m_objVaxServerSIP.OnSendNotifyMsgSuccess, AddressOf OnSendNotifyMsgSuccess
        AddHandler m_objVaxServerSIP.OnSendNotifyMsgFailed, AddressOf OnSendNotifyMsgFailed



    End Sub

#Region "Functions"

    Public Function GetVersionSDK() As String
        Return m_objVaxServerSIP.GetVersionSDK()
    End Function

    Public Function GetVersionFile() As String
        Return m_objVaxServerSIP.GetVersionFile()
    End Function

    Public Sub SetLicenseKey(ByVal sLicenseKey As String)
        m_objVaxServerSIP.SetLicenseKey(sLicenseKey)
    End Sub

    Public Function Initialize(ByVal sDomainRealm As String, ByVal sSIPListenIP As String, ByVal nSIPListenPort As Integer, ByVal sRTPListenIP As String, ByVal nRTPListenPort As Integer) As Boolean
        Return m_objVaxServerSIP.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort)
    End Function

    Public Sub UnInitialize()
        m_objVaxServerSIP.UnInitialize()
    End Sub

    Public Function SetListenPortRangeRTP(ByVal nListenStartPort As Integer, ByVal nListenEndPort As Integer) As Boolean
        Return m_objVaxServerSIP.SetListenPortRangeRTP(nListenStartPort, nListenEndPort)
    End Function

    Public Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sCodecList As String) As Boolean
        Return m_objVaxServerSIP.AddUser(sUserName, sPassword, sCodecList)
    End Function

    Public Sub RemoveUser(ByVal sUserName As String)
        m_objVaxServerSIP.RemoveUser(sUserName)
    End Sub

    Public Function RegisterUserExpiry(ByVal nExpiry As Integer) As Boolean
        Return m_objVaxServerSIP.RegisterUserExpiry(nExpiry)
    End Function

    Public Function AcceptRegister(ByVal nRegId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptRegister(nRegId)
    End Function

    Public Function RejectRegister(ByVal nRegId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerSIP.RejectRegister(nRegId, nStatusCode, sReasonPhrase)
    End Function

    Public Function AuthRegister(ByVal nRegId As Integer) As Boolean
        Return m_objVaxServerSIP.AuthRegister(nRegId)
    End Function

    Public Function AddLine(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxySIP As String, ByVal sOutboundProxySIP As String, ByVal sCodecList As String) As Boolean
        Return m_objVaxServerSIP.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList)
    End Function

    Public Sub RemoveLine(ByVal sLineName As String)
        m_objVaxServerSIP.RemoveLine(sLineName)
    End Sub

    Public Function RegisterLine(ByVal sLineName As String, ByVal nExpire As Integer) As Boolean
        Return m_objVaxServerSIP.RegisterLine(sLineName, nExpire)
    End Function

    Public Function UnRegisterLine(ByVal sLineName As String) As Boolean
        Return m_objVaxServerSIP.UnRegisterLine(sLineName)
    End Function

    Public Function AddDirectProxySIP(ByVal sProxyName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxyIP As String, ByVal nProxyPort As Integer, ByVal sCodecList As String) As Boolean
        Return m_objVaxServerSIP.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)
    End Function

    Public Sub RemoveDirectProxySIP(ByVal sProxyName As String)
        m_objVaxServerSIP.RemoveDirectProxySIP(sProxyName)
    End Sub

    Public Function AcceptCallSession(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout)
    End Function

    Public Sub RejectCallSession(ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objVaxServerSIP.RejectCallSession(nSessionId, nStatusCode, sReasonPhrase)
    End Sub

    Public Sub CloseCallSession(ByVal nSessionId As Integer)
        m_objVaxServerSIP.CloseCallSession(nSessionId)
    End Sub

    Public Function DialCallSession(ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Integer
        Return m_objVaxServerSIP.DialCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout)
    End Function

    Public Function AcceptTransferBlind(ByVal nTransfererSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sTransferTo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptTransferBlind(nTransfererSessionId, sCallerName, sCallerId, sTransferTo, nToPeerType, sToPeerName, nTimeout)
    End Function

    Public Function AcceptTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransferToSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptTransferConsult(nTransfererSessionId, nTransferToSessionId)
    End Function

    Public Sub RejectTransfer(ByVal nSessionId As Integer)
        m_objVaxServerSIP.RejectTransfer(nSessionId)
    End Sub

    Public Function PlayWaveStartToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer, ByVal bLoop As Boolean, ByVal nPlayPosPCM As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveStartToCallSession(nSessionId, nChannelId, nWaveId, bLoop, nPlayPosPCM)
    End Function

    Public Sub PlayWaveStopToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)
        m_objVaxServerSIP.PlayWaveStopToCallSession(nSessionId, nChannelId, nWaveId)
    End Sub

    Public Function PlayWaveSetVolumeToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer, ByVal nVolume As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveSetVolumeToCallSession(nSessionId, nChannelId, nWaveId, nVolume)
    End Function

    Public Function PlayWaveSetModeTypeToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nPlayModeType As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveSetModeTypeToCallSession(nSessionId, nChannelId, nPlayModeType)
    End Function

    Public Function RecordWaveStartToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sFileName As String) As Boolean
        Return m_objVaxServerSIP.RecordWaveStartToCallSession(nSessionId, nChannelId, sFileName)
    End Function

    Public Sub RecordWaveStopToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
        m_objVaxServerSIP.RecordWaveStopToCallSession(nSessionId, nChannelId)
    End Sub

    Public Function RecordWavePauseToCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.RecordWavePauseToCallSession(nSessionId, nChannelId, bEnable)
    End Function

    Public Function LoadWaveFile(ByVal sFileName As String) As Integer
        Return m_objVaxServerSIP.LoadWaveFile(sFileName)
    End Function

    Public Function LoadWavePCM(ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer) As Integer

        Dim hHandleGC As GCHandle = GCHandle.Alloc(aDataPCM, GCHandleType.Pinned)
        Dim AddrDataPCM As IntPtr = hHandleGC.AddrOfPinnedObject()
        Dim lDataPCM As Long = AddrDataPCM.ToInt64()

        Dim nWaveId As Integer = m_objVaxServerSIP.LoadWavePCM(lDataPCM, nSizePCM, 0)

        hHandleGC.Free()
        Return nWaveId

    End Function

    Public Sub UnLoadWaveFile(ByVal nWaveId As Integer)
        m_objVaxServerSIP.UnLoadWaveFile(nWaveId)
    End Sub

    Public Function LoadMusicHold(ByVal sFileName As String) As Boolean
        Return m_objVaxServerSIP.LoadMusicHold(sFileName)
    End Function

    Public Sub UnLoadMusicHold()
        m_objVaxServerSIP.UnLoadMusicHold()
    End Sub

    Public Function AcceptOnHoldRequest(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptOnHoldRequest(nSessionId)
    End Function

    Public Function AcceptOffHoldRequest(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptOffHoldRequest(nSessionId)
    End Function

    Public Function AcceptChatMessage(ByVal nChatMsgId As Integer, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean
        Return m_objVaxServerSIP.AcceptChatMessage(nChatMsgId, nToPeerType, sToPeerName)
    End Function

    Public Sub RejectChatMessage(ByVal nChatMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objVaxServerSIP.RejectChatMessage(nChatMsgId, nStatusCode, sReasonPhrase)
    End Sub

    Public Function AcceptChatStatusSubscribe(ByVal nStatusSubscribe As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean
        Return m_objVaxServerSIP.AcceptChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo, nToPeerType, sToPeerName)
    End Function

    Public Sub RejectChatStatusSubscribe(ByVal nStatusSubscribe As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String)
        m_objVaxServerSIP.RejectChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo)
    End Sub

    Public Function OpenConferenceRoom(ByVal sRoomName As String) As Boolean
        Return m_objVaxServerSIP.OpenConferenceRoom(sRoomName)
    End Function

    Public Sub CloseConferenceRoom(ByVal sRoomName As String)
        m_objVaxServerSIP.CloseConferenceRoom(sRoomName)
    End Sub

    Public Function AddCallSessionToConferenceRoom(ByVal sRoomName As String, ByVal nSessionId As Integer, ByVal nVoiceTypeId As Integer) As Boolean
        Return m_objVaxServerSIP.AddCallSessionToConferenceRoom(sRoomName, nSessionId, nVoiceTypeId)
    End Function

    Public Function RemoveCallSessionFromConferenceRoom(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.RemoveCallSessionFromConferenceRoom(nSessionId)
    End Function

    Public Function PlayWaveStartToConferenceRoom(ByVal sRoomName As String, ByVal nWaveId As Integer, ByVal bLoop As Boolean, ByVal nPlayPosPCM As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveStartToConferenceRoom(sRoomName, nWaveId, bLoop, nPlayPosPCM)
    End Function

    Public Function PlayWaveStopToConferenceRoom(ByVal sRoomName As String, ByVal nWaveId As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveStopToConferenceRoom(sRoomName, nWaveId)
    End Function


    Public Function PlayWaveSetVolumeToConferenceRoom(ByVal sRoomName As String, ByVal nWaveId As Integer, ByVal nVolume As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveSetVolumeToConferenceRoom(sRoomName, nWaveId, nVolume)
    End Function

    Public Function RecordWaveStartToConferenceRoom(ByVal sRoomName As String, ByVal sFileName As String) As Boolean
        Return m_objVaxServerSIP.RecordWaveStartToConferenceRoom(sRoomName, sFileName)
    End Function

    Public Function RecordWaveStopToConferenceRoom(ByVal sRoomName As String) As Boolean
        Return m_objVaxServerSIP.RecordWaveStopToConferenceRoom(sRoomName)
    End Function

    Public Function RecordWavePauseToConferenceRoom(ByVal sRoomName As String, ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.RecordWavePauseToConferenceRoom(sRoomName, bEnable)
    End Function

    Public Function VoiceSessionLost(ByVal bEnable As Boolean, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.VoiceSessionLost(bEnable, nTimeout)
    End Function

    Public Function SendInfoVM(ByVal sUserLogin As String, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal bMsgWaiting As Boolean) As Integer
        Return m_objVaxServerSIP.SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting)
    End Function

    Public Function StartVaxTeleTick(ByVal nTickId As Integer, ByVal nElapse As Integer) As Boolean
        Return m_objVaxServerSIP.StartVaxTeleTick(nTickId, nElapse)
    End Function

    Public Function StopVaxTeleTick(ByVal nTickId As Integer) As Boolean
        Return m_objVaxServerSIP.StopVaxTeleTick(nTickId)
    End Function

    Public Function SetUserAgentName(ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.SetUserAgentName(sName)
    End Function

    Public Function GetUserAgentName() As String
        Return m_objVaxServerSIP.GetUserAgentName().ToString()
    End Function

    Public Function SetSessionNameSDP(ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.SetSessionNameSDP(sName)
    End Function

    Public Function GetSessionNameSDP() As String
        Return m_objVaxServerSIP.GetSessionNameSDP().ToString()
    End Function

    Public Function SendDTMFCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nTypeDTMF As Integer, ByVal nDigit As Integer) As Boolean
        Return m_objVaxServerSIP.SendDTMFCallSession(nSessionId, nChannelId, nTypeDTMF, nDigit)
    End Function

    Public Function DetectDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nTypeDTMF As Integer, ByVal bEnable As Boolean, ByVal nMilliSecondTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.DetectDigitDTMF(nSessionId, nChannelId, nTypeDTMF, bEnable, nMilliSecondTimeout)
    End Function

    Public Function GetVaxErrorCode() As Integer
        Return m_objVaxServerSIP.GetVaxErrorCode()
    End Function

    Public Function DialToneToCallSession(ByVal bEnable As Boolean, ByVal nSessionId As Integer, ByVal nWaveId As Integer) As Boolean
        Return m_objVaxServerSIP.DialToneToCallSession(bEnable, nSessionId, nWaveId)
    End Function

    Public Function DiagnosticLogSIP(ByVal bInbound As Boolean, ByVal bOutbound As Boolean) As Boolean
        Return m_objVaxServerSIP.DiagnosticLogSIP(bInbound, bOutbound)
    End Function

    Public Function SplitCallSession(ByVal nFromSessionId As Integer, ByVal nChannelId As Integer) As Integer
        Return m_objVaxServerSIP.MergeCallSession(nFromSessionId, nChannelId)
    End Function

    Public Function MoveCall(ByVal nSrcSessionId As Integer, ByVal nChannelId As Integer, ByVal nDscSessionId As Integer) As Integer
        Return m_objVaxServerSIP.MoveCall(nSrcSessionId, nChannelId, nDscSessionId)
    End Function

    Public Function CallSessionSendStatusResponse(ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContactURI As String)
        Return m_objVaxServerSIP.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, sContactURI)
    End Function

    Public Function CallSessionDetectAMD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bEnable As Boolean, ByVal nAnalysisTime As Integer, ByVal nSilenceTime As Integer, ByVal nSilenceCount As Integer) As Boolean
        Return m_objVaxServerSIP.CallSessionDetectAMD(nSessionId, nChannelId, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount)
    End Function

    Public Function AddCustomHeader(ByVal nReqId As Integer, ByVal sName As String, ByVal sValue As String) As Boolean
        Return m_objVaxServerSIP.AddCustomHeader(nReqId, sName, sValue)
    End Function

    Public Function RemoveCustomHeader(ByVal nReqId As Integer, ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.RemoveCustomHeader(nReqId, sName)
    End Function

    Public Function RemoveCustomHeaderAll(ByVal nReqId As Integer) As Boolean
        Return m_objVaxServerSIP.RemoveCustomHeaderAll(nReqId)
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function GetCallSessionTxCodec(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
        Return m_objVaxServerSIP.GetCallSessionTxCodec(nSessionId, nChannelId)
    End Function

    Public Function GetCallSessionRxCodec(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As Integer
        Return m_objVaxServerSIP.GetCallSessionRxCodec(nSessionId, nChannelId)
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function BusyLampSubscribeAccept(ByVal nSubScrbId As Integer, ByVal bAuthenticate As Boolean, ByVal nExpires As Integer) As Boolean
        Return m_objVaxServerSIP.BusyLampSubscribeAccept(nSubScrbId, bAuthenticate, nExpires)
    End Function

    Public Function BusyLampSubscribeReject(ByVal nSubScrbId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerSIP.BusyLampSubscribeReject(nSubScrbId, nStatusCode, sReasonPhrase)
    End Function

    Public Function BusyLampSendStatus(ByVal sFromUserName As String, ByVal sToUserName As String, ByVal nStateId As Integer)
        Return m_objVaxServerSIP.BusyLampSendStatus(sFromUserName, sToUserName, nStateId)
    End Function


    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetCallSessionData(ByVal nSessionId As Integer, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetCallSessionData(nSessionId, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetCallSessionData(ByVal nSessionId As Integer) As Object

        Dim lData As Long = m_objVaxServerSIP.GetCallSessionData(nSessionId)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeCallSessionData(ByVal nSessionId As Integer)

        Dim lData As Long = m_objVaxServerSIP.GetCallSessionData(nSessionId)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetUserData(ByVal sUserName As String, ByVal objCustomData As Object)

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetUserData(sUserName, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetUserData(ByVal sUserName As String) As Object

        Dim lData As Long = m_objVaxServerSIP.GetUserData(sUserName)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeUserData(ByVal sUserName As String)

        Dim lData As Long = m_objVaxServerSIP.GetUserData(sUserName)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetLineData(ByVal sLineName As String, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetLineData(sLineName, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetLineData(ByVal sLineName As String) As Object

        Dim lData As Long = m_objVaxServerSIP.GetLineData(sLineName)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeLineData(ByVal sLineName As String)

        Dim lData As Long = m_objVaxServerSIP.GetLineData(sLineName)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetDirectProxyData(ByVal sProxyName As String, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetDirectProxyData(sProxyName, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetDirectProxyData(ByVal sProxyName As String) As Object

        Dim lData As Long = m_objVaxServerSIP.GetDirectProxyData(sProxyName)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeDirectProxyData(ByVal sProxyName As String)

        Dim lData As Long = m_objVaxServerSIP.GetDirectProxyData(sProxyName)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetConferenceRoomData(ByVal sRoomName As String, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetConferenceRoomData(sRoomName, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetConferenceRoomData(ByVal sRoomName As String) As Object

        Dim lData As Long = m_objVaxServerSIP.GetDirectProxyData(sRoomName)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeConferenceRoomData(ByVal sRoomName As String)

        Dim lData As Long = m_objVaxServerSIP.GetConferenceRoomData(sRoomName)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function TrvsUserStart() As Boolean
        Return m_objVaxServerSIP.TrvsUserStart()
    End Function

    Public Function TrvsUserNext() As String
        Return m_objVaxServerSIP.TrvsUserNext()
    End Function

    Public Function TrvsLineStart() As Boolean
        Return m_objVaxServerSIP.TrvsLineStart()
    End Function

    Public Function TrvsLineNext() As String
        Return m_objVaxServerSIP.TrvsLineNext()
    End Function

    Public Function TrvsDirectProxyStart() As Boolean
        Return m_objVaxServerSIP.TrvsDirectProxyStart()
    End Function

    Public Function TrvsDirectProxyNext() As String
        Return m_objVaxServerSIP.TrvsDirectProxyNext()
    End Function

    Public Function TrvsCallSessionStart() As Boolean
        Return m_objVaxServerSIP.TrvsCallSessionStart()
    End Function

    Public Function TrvsCallSessionNext() As Integer
        Return m_objVaxServerSIP.TrvsCallSessionNext()
    End Function

    Public Function TrvsConferenceRoomStart()
        Return m_objVaxServerSIP.TrvsConferenceRoomStart()
    End Function

    Public Function TrvsConferenceRoomNext() As String
        Return m_objVaxServerSIP.TrvsConferenceRoomNext()
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function GetCallCount() As Integer
        Return m_objVaxServerSIP.GetCallCount()
    End Function

    Public Function GetUserCount() As Integer
        Return m_objVaxServerSIP.GetUserCount()
    End Function

    Public Function GetLineCount() As Integer
        Return m_objVaxServerSIP.GetLineCount()
    End Function

    Public Function GetDirectProxyCount() As Integer
        Return m_objVaxServerSIP.GetDirectProxyCount()
    End Function

    Public Function GetCallSessionCount() As Integer
        Return m_objVaxServerSIP.GetCallSessionCount()
    End Function

    Public Function GetConferenceRoomCount() As Integer
        Return m_objVaxServerSIP.GetConferenceRoomCount()
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function CustomListOpen(ByVal nTableSize As Integer) As Integer
        Return m_objVaxServerSIP.CustomListOpen(nTableSize)
    End Function

    Public Function CustomListClose(ByVal nListId As Integer) As Boolean
        Return m_objVaxServerSIP.CustomListClose(nListId)
    End Function

    Public Function CustomListAddData(ByVal nListId As Integer, ByVal sKey As String, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.CustomListAddData(nListId, sKey, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function CustomListRemoveData(ByVal nListId As Integer, ByVal sKey As String) As Boolean

        Dim lData As Long = m_objVaxServerSIP.CustomListFindData(nListId, sKey)

        If (lData = 0) Then
            Return False
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

        Return m_objVaxServerSIP.CustomListRemoveData(nListId, sKey)

    End Function

    Public Function CustomListFindData(ByVal nListId As Integer, ByVal sKey As String) As Object

        Dim lData As Long = m_objVaxServerSIP.CustomListFindData(nListId, sKey)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Function CustomListCount(ByVal nListId As Integer) As Integer
        Return m_objVaxServerSIP.CustomListCount(nListId)
    End Function

    Public Function CustomListReset(ByVal nListId As Integer) As Boolean
        Return m_objVaxServerSIP.CustomListReset(nListId)
    End Function

    Public Function CustomListTrvsStart(ByVal nListId As Integer) As Boolean
        Return m_objVaxServerSIP.CustomListTrvsStart(nListId)
    End Function

    Public Function CustomListTrvsNext(ByVal nListId As Integer) As Object

        Dim lData As Long = m_objVaxServerSIP.CustomListTrvsNext(nListId)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Function GetCallSessionHeaderCallId(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As String
        Return m_objVaxServerSIP.GetCallSessionHeaderCallId(nSessionId, nChannelId)
    End Function

    Public Function CallSessionMuteVoice(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bListen As Boolean, ByVal bSpeak As Boolean) As Boolean
        Return m_objVaxServerSIP.CallSessionMuteVoice(nSessionId, nChannelId, bListen, bSpeak)
    End Function

    Public Function VideoCOMM(ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.VideoCOMM(bEnable)
    End Function


    Public Function AddRingGroup(ByVal sGroupName As String) As Boolean

        Return m_objVaxServerSIP.AddRingGroup(sGroupName)

    End Function

    Public Sub RemoveRingGroup(ByVal sGroupName As String)

        m_objVaxServerSIP.RemoveRingGroup(sGroupName)

    End Sub

    Public Function AddRingGroupAgent(ByVal sGroupName As String, ByVal sUserName As String) As Boolean

        Return m_objVaxServerSIP.AddRingGroupAgent(sGroupName, sUserName)

    End Function

    Public Sub RemoveRingGroupAgent(ByVal sGroupName As String, ByVal sUserName As String)

        m_objVaxServerSIP.RemoveRingGroupAgent(sGroupName, sUserName)

    End Sub

    Public Sub SetRingGroupProcessMode(ByVal sGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)

        m_objVaxServerSIP.SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType)

    End Sub

    Public Function SetRingGroupAgentPriority(ByVal sGroupName As String, ByVal sUserName As String, ByVal nPriority As Integer) As Boolean

        Return m_objVaxServerSIP.SetRingGroupAgentPriority(sGroupName, sUserName, nPriority)

    End Function

    Public Function AddCallSessionToRingGroup(ByVal sGroupName As String, ByVal sCallerName As String, ByVal sCallerId As String, ByVal nSessionId As Integer) As Boolean

        Return m_objVaxServerSIP.AddCallSessionToRingGroup(sGroupName, sCallerName, sCallerId, nSessionId)

    End Function

    ''///////////////////////////////////////////////////////////////////////////////////

    Public Function AddCallPickUpGroup(ByVal sGroupName As String) As Boolean

        Return m_objVaxServerSIP.AddCallPickUpGroup(sGroupName)

    End Function

    Public Sub RemoveCallPickUpGroup(ByVal sGroupName As String)

        m_objVaxServerSIP.RemoveCallPickUpGroup(sGroupName)

    End Sub

    Public Function AddCallPickUpGroupMember(ByVal sGroupName As String, ByVal sUserName As String) As Boolean

        Return m_objVaxServerSIP.AddCallPickUpGroupMember(sGroupName, sUserName)

    End Function

    Public Sub RemoveCallPickUpGroupMember(ByVal sGroupName As String, ByVal sUserName As String)

        m_objVaxServerSIP.RemoveCallPickUpGroupMember(sGroupName, sUserName)

    End Sub

    Public Function PickUpCall(ByVal nSessionId As Integer, ByVal sUserName As String) As Boolean

        Return m_objVaxServerSIP.PickUpCall(nSessionId, sUserName)

    End Function

    Public Function ParkCallSession(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nSlotId As Integer) As Boolean

        Return m_objVaxServerSIP.ParkCallSession(nSessionId, nChannelId, nSlotId)

    End Function

    Public Function ConnectToParkedCallSession(ByVal nSessionId, ByVal nChannelId, ByVal nSlotId) As Boolean

        Return m_objVaxServerSIP.ConnectToParkedCallSession(nSessionId, nChannelId, nSlotId)

    End Function

    Public Function AddQueue(ByVal sQueueName As String) As Boolean

        Return m_objVaxServerSIP.AddQueue(sQueueName)

    End Function

    Public Sub RemoveQueue(ByVal sQueueName As String)

        m_objVaxServerSIP.RemoveQueue(sQueueName)

    End Sub

    Public Function AddQueueAgent(ByVal sQueueName As String, ByVal sUserName As String) As Boolean

        Return m_objVaxServerSIP.AddQueueAgent(sQueueName, sUserName)

    End Function

    Public Sub RemoveQueueAgent(ByVal sQueueName As String, ByVal sUserName As String)

        m_objVaxServerSIP.RemoveQueueAgent(sQueueName, sUserName)

    End Sub

    Public Sub SetQueueAgentPriority(ByVal sQueueName As String, ByVal sUserName As String, ByVal nPriorityWeight As Integer)

        m_objVaxServerSIP.SetQueueAgentPriority(sQueueName, sUserName, nPriorityWeight)

    End Sub

    Public Function SetQueueAgentStatus(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nStatusId As Integer) As Boolean

        Return m_objVaxServerSIP.SetQueueAgentStatus(sQueueName, sAgentName, nStatusId)

    End Function

    Public Sub SetQueueProcessMode(ByVal sQueueName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)

        m_objVaxServerSIP.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType)

    End Sub


    Public Function AddCallSessionToQueue(ByVal sQueueName As String, ByVal sCallerName As String, ByVal sCallerId As String, ByVal nSessionId As Integer, ByVal nTimeout As Integer) As Boolean

        Return m_objVaxServerSIP.AddCallSessionToQueue(sQueueName, sCallerId, sCallerName, nSessionId, nTimeout)

    End Function

    Public Function AddStealthListener(ByVal nStealthSessionId As Integer, ByVal nCpaturePeerType As Integer, ByVal sCapturePeerName As String, ByVal nVoiceTypeId As Integer) As Boolean

        Return m_objVaxServerSIP.AddStealthListener(nStealthSessionId, nCpaturePeerType, sCapturePeerName, nVoiceTypeId)

    End Function

    Public Function SetExtDataREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sExData As String) As Boolean

        Return m_objVaxServerSIP.SetExtDataREC(nSessionId, nChannelId, sExData)

    End Function

    Public Function ConnectToServerREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Boolean

        Return m_objVaxServerSIP.ConnectToServerREC(nSessionId, nChannelId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout)

    End Function

    Public Function AdjustCallSessionVoiceType(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nVoiceTypeId As Integer) As Boolean

        Return m_objVaxServerSIP.AdjustCallSessionVoiceType(nSessionId, nChannelId, nVoiceTypeId)

    End Function

    Public Function AddNetworkRouteSIP(ByVal sAssignedIP As String, ByVal sRouterIP As String) As Boolean
        Return m_objVaxServerSIP.AddNetworkRouteSIP(sAssignedIP, sRouterIP)
    End Function

    Public Function AddNetworkRouteRTP(ByVal sAssignedIP As String, ByVal sRouterIP As String) As Boolean
        Return m_objVaxServerSIP.AddNetworkRouteRTP(sAssignedIP, sRouterIP)
    End Function

    Public Function SendNotifyMsgSIP(ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Integer
        Return m_objVaxServerSIP.SendNotifyMsgSIP(sMsgFrom, sMsgTo, nToPeerType, sToPeerName)
    End Function

#End Region


#Region "Events"

    Public Overridable Sub OnLineRegisterTrying(ByVal sLineName As String)
    End Sub

    Public Overridable Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnLineRegisterSuccess(ByVal sLineName As String)
    End Sub

    Public Overridable Sub OnLineUnRegisterTrying(ByVal sLineName As String)
    End Sub

    Public Overridable Sub OnLineUnRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnLineUnRegisterSuccess(ByVal sLineName As String)
    End Sub

    Public Overridable Sub OnUnRegisterUser(ByVal sUserLogin As String)
    End Sub

    Public Overridable Sub OnRegisterUser(ByVal sUserLogin As String, ByVal sDomain As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub

    Public Overridable Sub OnRegisterUserSuccess(ByVal sUserLogin As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub


    Public Overridable Sub OnRegisterUserFailed(ByVal sUserLogin As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionCreated(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)
    End Sub

    Public Overridable Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nReasonCode As Integer)
    End Sub

    Public Overridable Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnCallSessionConnecting(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnCallSessionFailed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnCallSessionConnected(ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionLost(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionHangup(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionTimeout(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionCancelled(ByVal nSessionId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionOnHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionOffHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
    End Sub

    Public Overridable Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransferToChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
    End Sub

    Public Overridable Sub OnCallSessionTransfering(ByVal nSessionId As Integer, ByVal nTransferChannelId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnCallSessionTransferFailed(ByVal nSessionId As Integer, ByVal nTransferChannelId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnCallSessionTransferTimeout(ByVal nSessionId As Integer, ByVal nTransferChannelId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionTransfered(ByVal nSessionId As Integer, ByVal nTransferChannelId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnChatMessageText(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sMsgText As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnChatMessageTyping(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal bIsTypingStart As Boolean, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnChatStatusSubscribe(ByVal nSubscrbId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnChatStatusSendSubscribeSuccess(ByVal nSubscrbId As Integer)
    End Sub

    Public Overridable Sub OnChatStatusSendSubscribeFailed(ByVal nSubscrbId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub


    Public Overridable Sub OnChatMessageSuccess(ByVal nChatMsgId As Integer)
    End Sub

    Public Overridable Sub OnChatMessageFailed(ByVal nChatMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnChatMessageTimeout(ByVal nChatMsgId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sDigitDTMF As String)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnOutgoingDiagnosticLog(ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer)
    End Sub

    Public Overridable Sub OnIncomingDiagnosticLog(ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnVaxTeleTick(ByVal nTickId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnSendTimeoutVM(ByVal nMsgIdVM As Integer)
    End Sub

    Public Overridable Sub OnSendSuccessVM(ByVal nMsgIdVM As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionDialToneStart(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionDialToneStop(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionPlayWaveDone(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)
    End Sub

    Public Overridable Sub OnConferenceRoomPlayWaveDone(ByVal sRoomName As String, ByVal nWaveId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionDetectedAMD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bIsHuman As Boolean)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub OnCallSessionRecordedPCM(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)

        Dim aDataPCM() As Byte = New Byte(nSizePCM) {}
        Marshal.Copy(New IntPtr(lDataPCM), aDataPCM, 0, nSizePCM)

        OnCallSessionRecordedPCM(nSessionId, aDataPCM, nSizePCM)

    End Sub

    Public Overridable Sub OnCallSessionRecordedPCM(ByVal nSessionId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub OnConferenceRoomRecordedPCM(ByVal sRoomName As String, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)

        Dim aDataPCM() As Byte = New Byte(nSizePCM) {}
        Marshal.Copy(New IntPtr(lDataPCM), aDataPCM, 0, nSizePCM)

        OnConferenceRoomRecordedPCM(sRoomName, aDataPCM, nSizePCM)

    End Sub

    Public Overridable Sub OnConferenceRoomRecordedPCM(ByVal sRoomName As String, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnBusyLampSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnBusyLampUnSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnBusyLampSubscribeSuccess(ByVal nSubScrbId As Integer, ByVal sUserName As String)
    End Sub

    Public Overridable Sub OnBusyLampSubscribeFailed(ByVal nSubScrbId As Integer, ByVal sUserName As String)
    End Sub

    Public Overridable Sub OnBusyLampSendStatus(ByVal sFromUserName As String, ByVal sToUserName As String, ByVal nStateId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnVaxErrorLog(ByVal sFuncName As String, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
    End Sub

    Public Overridable Sub OnAddCallSessionToQueueSuccess(ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnAddCallSessionToQueueFailed(ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnAddCallSessionToRingGroupSuccess(ByVal sGroupName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnAddCallSessionToRingGroupFailed(ByVal sGroupName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnVaxLicenseChannel(ByVal nTotalChannels As Integer, ByVal nUsedChannels As Integer)
    End Sub

    Public Overridable Sub OnSendReqTransferCallTimeout(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnSendReqTransferCallAccepted(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnSendReqTransferCallFailed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnQualityReportPUBLISH(ByVal sMsgSIP As String, ByVal sMsgSDP As String, ByVal sFromIP As String, ByVal lFromPort As Integer)
    End Sub

    Public Overridable Sub OnServerConnectingREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnServerConnectedREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnServerFailedREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnServerTimeoutREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnServerHungupREC(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
    End Sub

    Public Overridable Sub OnQueuePlayWaveStart(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnQueuePlayWaveStop(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnQueueAgentConnectStarted(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnQueueAgentConnectTrying(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnQueueAgentConnectFailed(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnQueueAgentConnectTimeout(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnQueueAgentConnectSuccess(ByVal sQueueName As String, ByVal sAgentName As String, ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnSendNotifyMsgSuccess(ByVal nMsgId As Integer)
    End Sub

    Public Overridable Sub OnSendNotifyMsgFailed(ByVal nMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

#End Region


End Class
