﻿
Public Class cVaxServerExCOM : Inherits cVaxServerCOM

    Dim m_nDialToneId As Integer = -1
    Dim m_nMusicCallParkId As Integer = -1

    Dim m_bInitialized As Boolean = False

    Dim m_objRouteCallSIP As cVaxCallSessionRoute = Nothing
    Dim m_objConfRoom As cConfRoom = Nothing
    Dim m_objChat As cVaxChat = Nothing

    Dim m_objQueueList As cQueueList = Nothing
    Dim m_objRingGroupList As cRingGroupList = Nothing
    Dim m_objCallPickUpList As cCallPickUpList = Nothing
    Dim m_objRegUserList As cVaxRegUserList = Nothing

    Public Shared m_objServerExCOM As cVaxServerExCOM = Nothing

#Region "Functions"

    Sub New()

        m_objRouteCallSIP = New cVaxCallSessionRoute
        m_objConfRoom = New cConfRoom(Me)
        m_objChat = New cVaxChat(Me)
        m_objQueueList = New cQueueList()
        m_objRingGroupList = New cRingGroupList()
        m_objCallPickUpList = New cCallPickUpList()

        m_objRegUserList = New cVaxRegUserList()
        m_objServerExCOM = Me

    End Sub

    Public Overloads Sub SetLicenseKey(ByVal sLicenseKey As String)

            MyBase.SetLicenseKey(sLicenseKey)

    End Sub

    Public Overloads Function Initialize(ByVal sDomainRealm As String, ByVal sSIPListenIP As String, ByVal nSIPListenPort As Integer, ByVal sRTPListenIP As String, ByVal nRTPListenPort As Integer) As Boolean

        If (MyBase.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort) = False) Then
            Return False
        End If

        m_bInitialized = True
        OnInitialize()

        Return True

    End Function

    Public Overloads Sub UnInitialize()

        m_bInitialized = False

        m_objConfRoom.DeleteRoomAll()

        DeleteUserDataAll()
        DeleteCallSessionDataAll()

        m_objQueueList.DeleteQueueAll()
        m_objRingGroupList.DeleteRingGroupAll()
        m_objCallPickUpList.DeletePickUpGroupAll()

        m_objRegUserList.DeleteUserDataAll()

        MyBase.UnInitialize()

    End Sub


    Public Function IsInitialized() As Boolean
        Return m_bInitialized
    End Function


    Public Overloads Function AcceptCallSession(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean
        Return MyBase.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, 20)
    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sCodecList As String, ByVal bBlocked As Boolean, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bStealthListen As Boolean) As Boolean

        If (Not MyBase.AddUser(sUserName, sPassword, sCodecList)) Then
            Return False
        End If

        Dim objUser As cVaxUserData = New cVaxUserData()
        MyBase.SetUserData(sUserName, objUser)

        objUser.SetData(sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName, bStealthListen)

        Return True

    End Function

    Public Overloads Sub RemoveUser(ByVal sUserName As String)

        If (IsUserExist(sUserName) = False) Then
            Return
        End If

        MyBase.FreeUserData(sUserName)
        MyBase.RemoveUser(sUserName)

    End Sub

    Public Function IsUserExist(ByVal sUserName As String) As Boolean

        MyBase.TrvsUserStart()

        While (True)

            Dim sUser As String = MyBase.TrvsUserNext()
            If (sUser.Length = 0) Then
                Exit While
            End If

            If (sUser = sUserName) Then
                Return True
            End If

        End While

        Return False

    End Function

    Public Function IsUserBlocked(ByVal sUserName As String) As Boolean

        Dim objUser As cVaxUserData = CType(MyBase.GetUserData(sUserName), cVaxUserData)

        If (objUser Is Nothing) Then
            Return False
        End If

        Return objUser.IsUserBlocked()

    End Function

    Public Function IsUserRegistered(ByVal sUserName As String) As Boolean

        Dim objUser As cVaxUserData = CType(MyBase.GetUserData(sUserName), cVaxUserData)

        If (objUser Is Nothing) Then
            Return False
        End If

        Return objUser.IsRegistered()

    End Function

    Public Sub SetRegUser(ByVal sUserName As String, ByVal bRegUser As Boolean)

        Dim objUser As cVaxUserData = CType(MyBase.GetUserData(sUserName), cVaxUserData)

        If (objUser Is Nothing) Then
            Return
        End If

        objUser.SetRegUser(bRegUser)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddLine(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxySIP As String, ByVal sCodecList As String, ByVal bRegister As Boolean, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bBlocked As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sGroupName As String) As Boolean

        If (Not MyBase.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, "", sCodecList)) Then
            Return False
        End If

        Dim objLine As cVaxLine = New cVaxLine(Me)
        MyBase.SetLineData(sLineName, objLine)

        objLine.SetData(sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bBlocked, sRoomName, sQueueName, sGroupName)

        If (bRegister) Then
            MyBase.RegisterLine(sLineName, 1800)
        End If

        Return True

    End Function

    Public Overloads Sub RemoveLine(ByVal sLineName As String)

        If (IsLineExist(sLineName) = False) Then
            Return
        End If

        MyBase.FreeLineData(sLineName)
        MyBase.RemoveLine(sLineName)

    End Sub

    Public Function IsLineExist(ByVal sLineName As String)

        MyBase.TrvsLineStart()

        While (True)

            Dim sLine As String = MyBase.TrvsLineNext()
            If (sLine.Length = 0) Then
                Exit While
            End If

            If (sLine = sLineName) Then
                Return True
            End If

        End While

        Return False

    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddDirectProxySIP(ByVal sProxyName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxyIP As String, ByVal nProxyPort As Integer, ByVal sCodecList As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String) As Boolean

        If (Not MyBase.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)) Then
            Return False
        End If

        Dim objProxy As cVaxDirectProxy = New cVaxDirectProxy(Me)
        MyBase.SetDirectProxyData(sProxyName, objProxy)

        objProxy.SetData(sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)
        Return True

    End Function

    Public Overloads Sub RemoveDirectProxySIP(ByVal sProxyName As String)

        If (IsDirectProxyExist(sProxyName) = False) Then
            Return
        End If

        MyBase.FreeDirectProxyData(sProxyName)
        MyBase.RemoveDirectProxySIP(sProxyName)

    End Sub

    Public Function IsDirectProxyExist(ByVal sProxyName As String)

        MyBase.TrvsDirectProxyStart()

        While (True)

            Dim sProxy As String = MyBase.TrvsDirectProxyNext()
            If (sProxy.Length = 0) Then
                Exit While
            End If

            If (sProxy = sProxyName) Then
                Return True
            End If

        End While

        Return False

    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function GetVaxErrorCode() As Integer

        Return MyBase.GetVaxErrorCode()

    End Function

    Public Overloads Function DialToneToCallSession(ByVal bEnable As Boolean, ByVal nSessionId As Integer) As Boolean

        If (m_nDialToneId = -1) Then
            Return True
        End If

        Return MyBase.DialToneToCallSession(bEnable, nSessionId, m_nDialToneId)

    End Function

    Public Overloads Function GetCallCount() As Integer

        Return MyBase.GetCallCount()

    End Function

    Public Function GetRegisteredUserCount() As Integer

        Return m_objRegUserList.GetRegUserCount()

    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Function AddRoom(ByVal sRoomName As String, ByVal sRoomNo As String) As Boolean

        Return m_objConfRoom.AddRoom(sRoomName, sRoomNo)

    End Function

    Public Sub RemoveRoom(ByVal sRoomName As String)

        m_objConfRoom.RemoveRoom(sRoomName)

    End Sub

    Public Function IsRoomNoExists(ByVal sRoomNo As String) As Boolean

        Return m_objConfRoom.IsRoomNoExists(sRoomNo)

    End Function

    Public Function GetRoomName(ByVal sRoomNo As String) As String

        Return m_objConfRoom.GetRoomName(sRoomNo)

    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function LoadMusicDialTone(ByVal sFileName As String) As Boolean

        UnLoadMusicDialTone()

        m_nDialToneId = MyBase.LoadWaveFile(sFileName)
        Return (m_nDialToneId <> -1)

    End Function

    Public Overloads Sub UnLoadMusicDialTone()

        If (m_nDialToneId <> -1) Then
            MyBase.UnLoadWaveFile(m_nDialToneId)
            m_nDialToneId = -1
        End If

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function LoadMusicCallPark(ByVal sFileName As String) As Boolean

        UnLoadMusicCallPark()

        m_nMusicCallParkId = MyBase.LoadWaveFile(sFileName)
        Return (m_nMusicCallParkId <> -1)

    End Function

    Public Function GetMusicCallParkingId() As Integer

        Return m_nMusicCallParkId

    End Function

    Public Overloads Sub UnLoadMusicCallPark()

        If (m_nMusicCallParkId <> -1) Then
            MyBase.UnLoadWaveFile(m_nMusicCallParkId)
            m_nMusicCallParkId = -1
        End If

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Function GetUserRouteInfo(ByVal sUserName As String, ByVal sUserDialedNo As String, ByRef sDialNo As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String)

        Return m_objRouteCallSIP.GetUserRouteInfo(sUserName, sUserDialedNo, sDialNo, nToPeerType, sToPeerName)

    End Function

    Public Function GetLineRouteInfo(ByVal sLineName As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String, ByRef sQueueName As String, ByRef sRingGroupName As String) As Boolean

        Return m_objRouteCallSIP.GetLineRouteInfo(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

    End Function

    Public Function GetDirectProxyRouteInfo(ByVal sProxyName As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String, ByRef sQueueName As String, ByRef sRingGroupName As String) As Boolean

        Return m_objRouteCallSIP.GetDirectProxyRouteInfo(sProxyName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

    End Function

    Public Function AddUserRoute(ByVal sUserName As String, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean

        Return m_objRouteCallSIP.AddUserRoute(sUserName, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)

    End Function

    Public Sub RemoveUserRoute(ByVal sUserName As String)

        m_objRouteCallSIP.RemoveUserRoute(sUserName)

    End Sub

    Public Function AddLineRoute(ByVal sLineName As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String) As Boolean

        Return m_objRouteCallSIP.AddLineRoute(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

        
    End Function

    Public Sub RemoveLineRoute(ByVal sLineName As String)

        m_objRouteCallSIP.RemoveLineRoute(sLineName)

    End Sub

    Public Function AddDirectProxyRoute(ByVal sProxyName As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String) As Boolean

        Return m_objRouteCallSIP.AddDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

    End Function

    Public Sub RemoveDirectProxyRoute(ByVal sProxyName As String)

        m_objRouteCallSIP.RemoveDirectProxyRoute(sProxyName)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Sub DeleteCallSessionDataAll()

        MyBase.TrvsCallSessionStart()

        For nCount As Integer = 0 To (MyBase.GetCallSessionCount() - 1)
            Dim nSessionId As Integer = MyBase.TrvsCallSessionNext()
            MyBase.FreeCallSessionData(nSessionId)
        Next

    End Sub

    Public Sub DeleteUserDataAll()

        MyBase.TrvsUserStart()

        For nCount As Integer = 0 To (MyBase.GetUserCount() - 1)
            Dim sUserName As String = MyBase.TrvsUserNext()
            MyBase.FreeUserData(sUserName)
        Next

    End Sub

    '///////////////////////////////////////////////////////////////////////////////////
    '////////////////////           Queue   ////////////////////////////////////////////

    Private Function LoadQueueMusic(ByVal sQueueName As String, ByVal sQueueMusic As String) As Integer

        Dim nQueueMusicId As Integer = GetQueueMusicId(sQueueName)

        If (nQueueMusicId <> -1) Then
            MyBase.UnLoadWaveFile(nQueueMusicId)
        End If

        nQueueMusicId = MyBase.LoadWaveFile(sQueueMusic)
        Return nQueueMusicId

    End Function

    Private Function LoadQueueDialTone(ByVal sQueueName As String, ByVal sQueueDialTone As String) As Integer

        Dim nQueueDialToneId As Integer = GetQueueDialToneId(sQueueName)

        If (nQueueDialToneId <> -1) Then
            MyBase.UnLoadWaveFile(nQueueDialToneId)
        End If

        nQueueDialToneId = MyBase.LoadWaveFile(sQueueDialTone)
        Return nQueueDialToneId

    End Function

    Public Overloads Function AddQueue(ByVal sQueueName As String, ByVal sQueueMusicFile As String, ByVal sQueueDialToneFile As String) As Boolean

        Dim nQueueMusicId As Integer = LoadQueueMusic(sQueueName, sQueueMusicFile)
        Dim nQueueDialToneId As Integer = LoadQueueMusic(sQueueName, sQueueDialToneFile)

        If (Not m_objQueueList.AddQueue(sQueueName, sQueueMusicFile, nQueueMusicId, sQueueDialToneFile, nQueueDialToneId)) Then Return False

        Return MyBase.AddQueue(sQueueName)

    End Function

    Public Overloads Sub RemoveQueue(ByVal sQueueName As String)

        Dim nQueueMusicId As Integer = GetQueueMusicId(sQueueName)

        If (nQueueMusicId <> -1) Then
            MyBase.UnLoadWaveFile(nQueueMusicId)
        End If

        Dim nQueueDialToneId As Integer = GetQueueDialToneId(sQueueName)

        If (nQueueDialToneId <> -1) Then
            MyBase.UnLoadWaveFile(nQueueDialToneId)
        End If

        m_objQueueList.RemoveQueue(sQueueName)
        MyBase.RemoveQueue(sQueueName)

    End Sub

    Public Function GetQueueMusicId(ByVal sQueueName As String) As Integer

        Return m_objQueueList.GetQueueMusicId(sQueueName)

    End Function

    Public Function GetQueueDialToneId(ByVal sQueueName As String) As Integer

        Return m_objQueueList.GetQueueDialToneId(sQueueName)

    End Function

    Public Overloads Function AddQueueAgent(ByVal sQueueName As String, ByVal sUserName As String) As Boolean

        If (Not m_objQueueList.AddQueueAgent(sQueueName, sUserName)) Then Return False

        Return MyBase.AddQueueAgent(sQueueName, sUserName)

    End Function

    Public Overloads Sub RemoveQueueAgent(ByVal sQueueName As String, ByVal sUserName As String)

        m_objQueueList.RemoveQueueAgent(sQueueName, sUserName)

        MyBase.RemoveQueueAgent(sQueueName, sUserName)

    End Sub

    Public Overloads Sub SetQueueAgentPriority(ByVal sQueueName As String, ByVal sUserName As String, ByVal nPriorityWeight As Integer)

        m_objQueueList.SetQueueAgentPriority(sQueueName, sUserName, nPriorityWeight)

        MyBase.SetQueueAgentPriority(sQueueName, sUserName, nPriorityWeight)

    End Sub

    Public Overloads Sub SetQueueProcessMode(ByVal sQueueName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)

        m_objQueueList.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType)

        MyBase.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType)

    End Sub

    '///////////////////////////////////////////////////////////////////////////////////
    '////////////////////       RingGroup   ////////////////////////////////////////////

    Public Overloads Function AddRingGroup(ByVal sGroupName As String) As Boolean

        If (Not m_objRingGroupList.AddRingGroup(sGroupName)) Then Return True

        Return MyBase.AddRingGroup(sGroupName)

    End Function

    Public Overloads Sub RemoveRingGroup(ByVal sGroupName As String)

        m_objRingGroupList.RemoveRingGroup(sGroupName)

        MyBase.RemoveRingGroup(sGroupName)

    End Sub

    Public Overloads Function AddRingGroupAgent(ByVal sGroupName As String, ByVal sUserName As String) As Boolean

        If (Not m_objRingGroupList.AddRingGroupAgent(sGroupName, sUserName)) Then Return False
        Return MyBase.AddRingGroupAgent(sGroupName, sUserName)

    End Function

    Public Overloads Sub RemoveRingGroupAgent(ByVal sGroupName As String, ByVal sUserName As String)

        m_objRingGroupList.RemoveRingGroupAgent(sGroupName, sUserName)
        MyBase.RemoveRingGroupAgent(sGroupName, sUserName)

    End Sub

    Public Overloads Sub SetRingGroupProcessMode(ByVal sGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)

        m_objRingGroupList.SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType)

        MyBase.SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType)

    End Sub

    Public Overloads Function SetRingGroupAgentPriority(ByVal sGroupName As String, ByVal sUserName As String, ByVal nPriority As Integer) As Boolean

        If (Not m_objRingGroupList.SetRingGroupAgentPriority(sGroupName, sUserName, nPriority)) Then Return False

        Return MyBase.SetRingGroupAgentPriority(sGroupName, sUserName, nPriority)

    End Function

    '///////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////  CallPickUp  ///////////////////////////////////////////

    Public Overloads Function AddCallPickUpGroup(ByVal sGroupName As String) As Boolean

        If (Not m_objCallPickUpList.AddCallPickUpGroup(sGroupName)) Then Return False
        Return MyBase.AddCallPickUpGroup(sGroupName)

    End Function

    Public Overloads Sub RemoveCallPickUpGroup(ByVal sGroupName As String)

        m_objCallPickUpList.RemoveCallPickUpGroup(sGroupName)

        MyBase.RemoveCallPickUpGroup(sGroupName)

    End Sub

    Public Overloads Function AddCallPickUpGroupMember(ByVal sGroupName As String, ByVal sMemberName As String) As Boolean

        If (Not m_objCallPickUpList.AddCallPickUpGroupMember(sGroupName, sMemberName)) Then Return False

        Return MyBase.AddCallPickUpGroupMember(sGroupName, sMemberName)

    End Function

    Public Overloads Sub RemoveCallPickUpGroupMember(ByVal sGroupName As String, ByVal sMemberName As String)

        m_objCallPickUpList.RemoveCallPickUpGroupMember(sGroupName, sMemberName)

        MyBase.RemoveCallPickUpGroupMember(sGroupName, sMemberName)

    End Sub

    Public Overloads Function PickUpCall(ByVal nSessionId As Integer, ByVal sMemberName As String) As Boolean

        Return MyBase.PickUpCall(nSessionId, sMemberName)

    End Function

    Public Sub GetFromPeerRouteinfo(ByVal nFromPeerType As Integer, ByVal sDialNo As String, ByVal sFromPeerName As String, ByRef sToPeerName As String, ByRef sDialToNo As String, ByRef sRoomName As String, ByRef sRingGroupName As String, ByRef sQueueName As String, ByRef nToPeerType As Integer, ByRef bRejected As Boolean)

        If (nFromPeerType = cVaxServerCOM.VAX_PEER_TYPE_USER) Then

            If (IsRoomNoExists(sDialNo)) Then
                sRoomName = GetRoomName(sDialNo)
            Else
                GetUserRouteInfo(sFromPeerName, sDialNo, sDialToNo, nToPeerType, sToPeerName)
            End If

        ElseIf (nFromPeerType = cVaxServerCOM.VAX_PEER_TYPE_LINE) Then
            GetLineRouteInfo(sFromPeerName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)
            sDialToNo = sToPeerName

        ElseIf (nFromPeerType = cVaxServerCOM.VAX_PEER_TYPE_DIRECT_PROXY) Then
            GetDirectProxyRouteInfo(sFromPeerName, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)
            sDialToNo = sToPeerName

        End If

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

#End Region

#Region "Events"

    Public Overrides Sub OnCallSessionCreated(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)

        Dim objCallSession As cVaxCallSession = New cVaxCallSession()
        MyBase.SetCallSessionData(nSessionId, objCallSession)

        objCallSession.OnCallSessionCreated(nSessionId, nReasonCode)

    End Sub

    Public Overrides Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nReasonCode As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)

        objCallSession.OnCallSessionClosed(nSessionId, nChannelId, nReasonCode)
        MyBase.FreeCallSessionData(nSessionId)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        Dim sToPeerName As String = "", sDialToNo = ""
        Dim sRingGroupName As String = "", sQueueName = "", sRoomName = ""

        Dim nToPeerType As Integer = -1
        Dim bRejected As Boolean = False

        cVaxServerExCOM.m_objServerExCOM.GetFromPeerRouteinfo(nFromPeerType, sDialNo, sFromPeerName, sToPeerName, sDialToNo, sRoomName, sRingGroupName, sQueueName, nToPeerType, bRejected)

        If (bRejected) Then

            RejectCallSession(nSessionId, 404, "Not Found")
            Return

        End If

        DialToneToCallSession(True, nSessionId)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnIncomingCall(nSessionId, sCallerName, sCallerId, sDialNo, sRoomName, sQueueName, sRingGroupName, nFromPeerType, sFromPeerName, nToPeerType, sToPeerName, sUserAgentName, sFromIP, nFromPort)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnCallSessionConnecting(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnCallSessionConnecting(nSessionId, nChannelId, nStatusCode, sReasonPhrase)

    End Sub

    Public Overrides Sub OnCallSessionConnected(ByVal nSessionId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnCallSessionConnected(nSessionId)

    End Sub

    Public Overrides Sub OnCallSessionFailed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnCallSessionFailed(nSessionId, nChannelId, nStatusCode, sReasonPhrase)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnCallSessionOnHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnCallSessionOnHold(nSessionId, nChannelId)

    End Sub

    Public Overrides Sub OnCallSessionOffHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnCallSessionOffHold(nSessionId, nChannelId)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nTransfererSessionId), cVaxCallSession)
        objCallSession.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo)

    End Sub

    Public Overrides Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransferToChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nTransfererSessionId), cVaxCallSession)
        objCallSession.OnCallSessionTransferConsult(nTransfererSessionId, nTransfererChannelId, nTransferToSessionId, nTransferToChannelId, sTransferer, sTransferee, sTransferTo)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sDigitDTMF As String)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnDetectedDigitDTMF(nSessionId, nChannelId, sDigitDTMF)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnLineRegisterTrying(ByVal sLineName As String)

        Dim objLine As cVaxLine = CType(MyBase.GetLineData(sLineName), cVaxLine)
        objLine.OnLineRegisterTrying(sLineName)

    End Sub

    Public Overrides Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        Dim objLine As cVaxLine = CType(MyBase.GetLineData(sLineName), cVaxLine)
        If (objLine Is Nothing) Then Return

        objLine.OnLineRegisterFailed(sLineName, nStatusCode, sReasonPhrase)

    End Sub

    Public Overrides Sub OnLineRegisterSuccess(ByVal sLineName As String)

        Dim objLine As cVaxLine = CType(MyBase.GetLineData(sLineName), cVaxLine)
        objLine.OnLineRegisterSuccess(sLineName)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnRegisterUser(ByVal sUserLogin As String, ByVal sDomain As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)

        Dim objVaxRegUser As cVaxRegUser = m_objRegUserList.AddRegUserData(sUserLogin)
        If (objVaxRegUser Is Nothing) Then Return

        objVaxRegUser.OnRegisterUser(sUserLogin, sDomain, sUserAgentName, sFromIP, nFromPort, nRegId)

    End Sub

    Public Overrides Sub OnRegisterUserSuccess(ByVal sUserLogin As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)

        Dim objVaxRegUser As cVaxRegUser = m_objRegUserList.AddRegUserData(sUserLogin)
        If (objVaxRegUser Is Nothing) Then Return

        objVaxRegUser.OnRegisterUserSuccess(sUserLogin, sFromIP, nFromPort, nRegId)

    End Sub

    Public Overrides Sub OnRegisterUserFailed(ByVal sUserLogin As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)

        Dim objVaxRegUser As cVaxRegUser = m_objRegUserList.AddRegUserData(sUserLogin)
        If (objVaxRegUser Is Nothing) Then Return

        objVaxRegUser.OnRegisterUserFailed(sUserLogin, sFromIP, nFromPort, nRegId)
        m_objRegUserList.RemoveRegUserData(sUserLogin)

    End Sub

    Public Overrides Sub OnUnRegisterUser(ByVal sUserLogin As String)

        Dim objVaxRegUser As cVaxRegUser = m_objRegUserList.AddRegUserData(sUserLogin)
        If (objVaxRegUser Is Nothing) Then Return

        objVaxRegUser.OnUnRegisterUser(sUserLogin)
        m_objRegUserList.RemoveRegUserData(sUserLogin)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnChatMessageText(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sMsgText As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        m_objChat.OnChatMessageText(nChatMsgId, sMsgFrom, sMsgTo, sMsgText, nFromPeerType, sFromPeerName, sFromIP, nFromPort)

    End Sub

    Public Overrides Sub OnChatMessageTyping(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal bIsTypingStart As Boolean, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        m_objChat.OnChatMessageTyping(nChatMsgId, sMsgFrom, sMsgTo, bIsTypingStart, nFromPeerType, sFromPeerName, sFromIP, nFromPort)

    End Sub

    Public Overrides Sub OnChatStatusSubscribe(ByVal nSubscrbId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        m_objChat.OnChatStatusSubscribe(nSubscrbId, sMsgFrom, sMsgTo, nFromPeerType, sFromPeerName, sFromIP, nFromPort)

    End Sub

    Public Overrides Sub OnChatMessageSuccess(ByVal nChatMsgId As Integer)

        m_objChat.OnChatMessageSuccess(nChatMsgId)

    End Sub

    Public Overrides Sub OnChatMessageFailed(ByVal nChatMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objChat.OnChatMessageFailed(nChatMsgId, nStatusCode, sReasonPhrase)

    End Sub

    Public Overrides Sub OnChatMessageTimeout(ByVal nChatMsgId As Integer)

        m_objChat.OnChatMessageTimeout(nChatMsgId)

    End Sub

    Public Overrides Sub OnAddCallSessionToQueueSuccess(ByVal sQueueName As String, ByVal nSessionId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnAddCallSessionToQueueSuccess(sQueueName, nSessionId)

    End Sub

    Public Overrides Sub OnAddCallSessionToQueueFailed(ByVal sQueueName As String, ByVal nSessionId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnAddCallSessionToQueueFailed(sQueueName, nSessionId)

    End Sub

    Public Overrides Sub OnQueuePlayWaveStart(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnQueuePlayWaveStart(nEventType, sQueueName, nSessionId)

    End Sub

    Public Overrides Sub OnQueuePlayWaveStop(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnQueuePlayWaveStop(nEventType, sQueueName, nSessionId)

    End Sub

    Public Overrides Sub OnAddCallSessionToRingGroupSuccess(ByVal sGroupName As String, ByVal nSessionId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnAddCallSessionToRingGroupSuccess(nSessionId, sGroupName)

    End Sub

    Public Overrides Sub OnAddCallSessionToRingGroupFailed(ByVal sGroupName As String, ByVal nSessionId As Integer)

        Dim objCallSession As cVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), cVaxCallSession)
        objCallSession.OnAddCallSessionToRingGroupFailed(nSessionId, sGroupName)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnBusyLampSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
        BusyLampSubscribeAccept(nSubScrbId, True, 30)
    End Sub

    Public Overrides Sub OnBusyLampUnSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overrides Sub OnBusyLampSubscribeSuccess(ByVal nSubScrbId As Integer, ByVal sUserName As String)
    End Sub

    Public Overrides Sub OnBusyLampSubscribeFailed(ByVal nSubScrbId As Integer, ByVal sUserName As String)
    End Sub

    Public Overrides Sub OnBusyLampSendStatus(ByVal sFromUserName As String, ByVal sToUserName As String, ByVal nStateId As Integer)
        BusyLampSendStatus(sFromUserName, sToUserName, nStateId)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Sub GenStatusLog(ByVal sStatus As String)

        OnStatusLog(sStatus)

    End Sub

    Public Overrides Sub OnVaxErrorLog(ByVal sFuncName As String, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)

        Dim sMsg As String = "[Method: " + sFuncName + "] [Error Msg: " + sErrorMsg + "] [Code: " + nErrorCode.ToString() + "]"
        OnErrorLog(sMsg)

    End Sub

    Public Overridable Sub OnInitialize()
    End Sub

    Public Overridable Sub OnStatusLog(ByVal sMsg As String)
    End Sub

    Public Overridable Sub OnErrorLog(ByVal sMsg As String)
    End Sub

#End Region


End Class

