﻿Public Class cVaxCallSession

    Dim m_bIsCallSessionAddedToRoom As Boolean = False

    Dim m_objVaxCall As cVaxCall
    Dim m_objVaxTransfer As cVaxTransfer
    Dim m_objVaxQueue As cVaxQueue
    Dim m_objVaxRingGroup As cVaxRingGroup
    Dim m_objVaxCallPickUp As cVaxCallPickUp
    Dim m_objVaxCallParking As cVaxCallParking
    Dim m_objVaxStealthListen As cVaxStealthListen
    Dim m_objVaxRoom As cVaxRoom
    Dim m_objVaxHold As cVaxHold
    Dim m_objVaxDTMF As cVaxDTMF
    Dim m_objVaxRecordPCM As cVaxRecordPCM
    Dim m_objVaxDialTone As cVaxDialTone
    Dim m_objVaxDetectedAMD As cVaxDetectedAMD

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub New()

        m_objVaxCall = New cVaxCall()
        m_objVaxTransfer = New cVaxTransfer()
        m_objVaxQueue = New cVaxQueue()
        m_objVaxRingGroup = New cVaxRingGroup()
        m_objVaxRoom = New cVaxRoom()
        m_objVaxHold = New cVaxHold()
        m_objVaxDTMF = New cVaxDTMF()
        m_objVaxRecordPCM = New cVaxRecordPCM()
        m_objVaxDialTone = New cVaxDialTone()
        m_objVaxDetectedAMD = New cVaxDetectedAMD()
        m_objVaxCallPickUp = New cVaxCallPickUp()
        m_objVaxCallParking = New cVaxCallParking()
        m_objVaxStealthListen = New cVaxStealthListen()

    End Sub


    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxCall  ///////////////////////////////////

    Public Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        Dim bProcessed As Boolean = False
        m_bIsCallSessionAddedToRoom = False

        m_objVaxRoom.OnIncomingCall(nSessionId, sRoomName, bProcessed)

        If (bProcessed) Then
            m_bIsCallSessionAddedToRoom = True
            Return
        End If

        m_objVaxQueue.OnIncomingCall(nSessionId, sCallerName, sCallerId, sQueueName, bProcessed) 'Try to process as Queue call.

        If (bProcessed) Then
            Return
        End If

        m_objVaxRingGroup.OnIncomingCall(nSessionId, sCallerName, sCallerId, sRingGroupName, bProcessed) 'Try to process as RingGroup call.

        If (bProcessed) Then
            Return
        End If

        m_objVaxCallParking.OnIncomingCall(nSessionId, sDialNo, nFromPeerType, bProcessed) 'Try to connect to Parked call.

        If (bProcessed) Then
            Return
        End If

        m_objVaxCallPickUp.OnIncomingCall(nSessionId, sDialNo, nFromPeerType, sFromPeerName, bProcessed) 'A user wants to pickup other user/extention's call.

        If (bProcessed) Then
            Return
        End If

        m_objVaxStealthListen.OnIncomingCall(nSessionId, sDialNo, nFromPeerType, bProcessed) 'Process for stealth-listening.

        If (bProcessed) Then
            Return
        End If

        m_objVaxCall.OnIncomingCall(nSessionId, sCallerName, sCallerId, sDialNo, nFromPeerType, sFromPeerName, nToPeerType, sToPeerName, bProcessed)   'Process as normal call.

    End Sub

    Public Sub OnCallSessionCreated(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)

        m_objVaxCall.OnCallSessionCreated(nSessionId, nReasonCode)

    End Sub

    Public Sub OnCallSessionConnecting(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objVaxCall.OnCallSessionConnecting(nSessionId, nChannelId, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnCallSessionFailed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objVaxCall.OnCallSessionFailed(nSessionId, nChannelId, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnCallSessionConnected(ByVal nSessionId As Integer)

        If (m_bIsCallSessionAddedToRoom) Then
            m_objVaxRoom.OnCallSessionConnected(nSessionId)
        Else
            m_objVaxCall.OnCallSessionConnected(nSessionId)
        End If

    End Sub

    Public Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nReasonCode As Integer)

        m_objVaxCall.OnCallSessionClosed(nSessionId, nChannelId, nReasonCode)

    End Sub

    Public Sub OnCallSessionLost(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        m_objVaxCall.OnCallSessionLost(nSessionId, nChannelId)

    End Sub

    Public Sub OnCallSessionHangup(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        m_objVaxCall.OnCallSessionHangup(nSessionId, nChannelId)

    End Sub

    Public Sub OnCallSessionTimeout(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        m_objVaxCall.OnCallSessionTimeout(nSessionId, nChannelId)

    End Sub

    Public Sub OnCallSessionCancelled(ByVal nSessionId As Integer)

        m_objVaxCall.OnCallSessionCancelled(nSessionId)

    End Sub

    Public Sub OnCallSessionOpenCall(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nPeerType As Integer, ByVal sPeerName As String)

        m_objVaxCall.OnCallSessionOpenCall(nSessionId, nChannelId, nPeerType, sPeerName)

    End Sub

    Public Sub OnCallSessionCloseCall(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nPeerType As Integer, ByVal sPeerName As String)

        m_objVaxCall.OnCallSessionCloseCall(nSessionId, nChannelId, nPeerType, sPeerName)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxHold  ///////////////////////////////////

    Public Sub OnCallSessionOnHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        If (m_bIsCallSessionAddedToRoom) Then
            m_objVaxRoom.OnCallSessionOnHold(nSessionId, nChannelId)
        Else
            m_objVaxHold.OnCallSessionOnHold(nSessionId, nChannelId)
        End If

    End Sub

    Public Sub OnCallSessionOffHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        If (m_bIsCallSessionAddedToRoom) Then
            m_objVaxRoom.OnCallSessionOffHold(nSessionId, nChannelId)
        Else
            m_objVaxHold.OnCallSessionOffHold(nSessionId, nChannelId)
        End If

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxTransfer  ///////////////////////////////

    Public Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)

        Dim bProcessed As Boolean = False

        m_objVaxCallParking.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo, bProcessed)

        If (bProcessed) Then
            Return
        End If

        If (m_bIsCallSessionAddedToRoom) Then
            m_objVaxRoom.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo)
        Else
            m_objVaxTransfer.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo)
        End If

    End Sub

    Public Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransferToChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)

        If (m_bIsCallSessionAddedToRoom) Then
            m_objVaxRoom.OnCallSessionTransferConsult(nTransfererSessionId, nTransfererChannelId, nTransferToSessionId, nTransferToChannelId, sTransferer, sTransferee, sTransferTo)
        Else
            m_objVaxTransfer.OnCallSessionTransferConsult(nTransfererSessionId, nTransfererChannelId, nTransferToSessionId, nTransferToChannelId, sTransferer, sTransferee, sTransferTo)
        End If

    End Sub

    Public Sub OnCallSessionTransfering(ByVal nSessionId As Integer, ByVal nTransferChannelId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objVaxTransfer.OnCallSessionTransfering(nSessionId, nTransferChannelId, nChannelId, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnCallSessionTransferFailed(ByVal nSessionId As Integer, ByVal nTransferChannelId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objVaxTransfer.OnCallSessionTransferFailed(nSessionId, nTransferChannelId, nChannelId, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnCallSessionTransferTimeout(ByVal nSessionId As Integer, ByVal nTransferChannelId As Integer, ByVal nChannelId As Integer)

        m_objVaxTransfer.OnCallSessionTransferTimeout(nSessionId, nTransferChannelId, nChannelId)

    End Sub

    Public Sub OnCallSessionTransfered(ByVal nSessionId As Integer, ByVal nTransferChannelId As Integer)

        m_objVaxTransfer.OnCallSessionTransfered(nSessionId, nTransferChannelId)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxDialTone  ///////////////////////////////

    Public Sub OnCallSessionDialToneStart(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)

        m_objVaxDialTone.OnCallSessionDialToneStart(nSessionId, nChannelId, nWaveId)

    End Sub

    Public Sub OnCallSessionDialToneStop(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nWaveId As Integer)

        m_objVaxDialTone.OnCallSessionDialToneStop(nSessionId, nChannelId, nWaveId)

    End Sub

    Public Sub OnCallSessionPlayWaveDone(ByVal nSessionId As Integer, ByVal nWaveId As Integer)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxDTMF  //////////////////////////////////

    Public Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sDigitDTMF As String)

        m_objVaxDTMF.OnDetectedDigitDTMF(nSessionId, nChannelId, sDigitDTMF)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxAMD  ///////////////////////////////////

    Public Sub OnCallSessionDetectedAMD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bIsHuman As Boolean)

        m_objVaxDetectedAMD.OnCallSessionDetectedAMD(nSessionId, nChannelId, bIsHuman)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxPCM  ///////////////////////////////////

    Public Sub OnCallSessionRecordedPCM(ByVal nSessionId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer)

        m_objVaxRecordPCM.OnCallSessionRecordedPCM(nSessionId, aDataPCM, nSizePCM)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxQueue  //////////////////////////////////

    Public Sub OnAddCallSessionToQueueSuccess(ByVal sQueueName As String, ByVal nSessionId As Integer)

        m_objVaxQueue.OnAddCallSessionToQueueSuccess(sQueueName, nSessionId)

    End Sub

    Public Sub OnAddCallSessionToQueueFailed(ByVal sQueueName As String, ByVal nSessionId As Integer)

        m_objVaxQueue.OnAddCallSessionToQueueFailed(sQueueName, nSessionId)

    End Sub

    Public Sub OnQueuePlayWaveStart(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)

        m_objVaxQueue.OnQueuePlayWaveStart(nEventType, sQueueName, nSessionId)

    End Sub

    Public Sub OnQueuePlayWaveStop(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)

        m_objVaxQueue.OnQueuePlayWaveStop(nEventType, sQueueName, nSessionId)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '///////////////////////////  cVaxRingGroup  //////////////////////////////

    Public Sub OnAddCallSessionToRingGroupSuccess(ByVal sGroupName As String, ByVal nSessionId As Integer)

        m_objVaxRingGroup.OnAddCallSessionToRingGroupSuccess(sGroupName, nSessionId)

    End Sub

    Public Sub OnAddCallSessionToRingGroupFailed(ByVal sGroupName As String, ByVal nSessionId As Integer)

        m_objVaxRingGroup.OnAddCallSessionToRingGroupFailed(sGroupName, nSessionId)

    End Sub

End Class





