#include "StdAfx.h"
#include "StoreQueue.h"

#define SUB_KEY_BUFFER_SIZE	2000

#define ROOT_PATH	"Queues\\"

CStoreQueue::CStoreQueue(void)
{
	
}

CStoreQueue::~CStoreQueue(void)
{
	
}

BOOL CStoreQueue::AddQueue(LPCTSTR sQueueName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);

	CStoreRegistry::SetTEXT(sKeyPath, "QueueName", sQueueName);
	return TRUE;
}

BOOL CStoreQueue::RemoveQueue(LPCTSTR sQueueName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);

	CStoreRegistry::DeleteSubKey(sKeyPath);	
	return TRUE;
}

BOOL CStoreQueue::GetQueueNameAll(CStringList* pListQueueName)
{
	CString sKeyPath =  ROOT_PATH;

	CStoreRegistry::EnumSubKeys(sKeyPath, pListQueueName);
	return TRUE;
}

BOOL CStoreQueue::SetMusicFile(LPCTSTR sQueueName, LPCTSTR sFileName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);

	CStoreRegistry::SetTEXT(sKeyPath, "MusicFileName", sFileName);

	return TRUE;

}

BOOL CStoreQueue::GetMusicFile(LPCTSTR sQueueName, CString& sFileName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);

	CStoreRegistry::GetTEXT(sKeyPath, "MusicFileName", sFileName);
	return TRUE;
}

BOOL CStoreQueue::SetDialToneFile(LPCTSTR sQueueName, LPCTSTR sFileName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);

	CStoreRegistry::SetTEXT(sKeyPath, "DialToneFileName", sFileName);
	return TRUE;
}

BOOL CStoreQueue::GetDialToneFile(LPCTSTR sQueueName, CString& sDialToneMusic)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);
	CStoreRegistry::GetTEXT(sKeyPath, "DialToneFileName", sDialToneMusic);

	return TRUE;
}

BOOL CStoreQueue::AddQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sQueueName, "\\",  sAgentName);

	CStoreRegistry::SetTEXT(sKeyPath, "UserName", sAgentName);
	return TRUE;
}

BOOL CStoreQueue::GetQueueAgentNameAll(LPCTSTR sQueueName, CStringList* pAgentName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);

	CStoreRegistry::EnumSubKeys(sKeyPath, pAgentName);
	return TRUE;
}

BOOL CStoreQueue::RemoveQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sQueueName, +"\\", sAgentName);

	 CStoreRegistry::DeleteSubKey(sKeyPath);
		
	return TRUE;
}

BOOL CStoreQueue::SetQueueAgentPriority(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG lPriority)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sQueueName, +"\\", sAgentName);

	CStoreRegistry::SetINT(sKeyPath, "Priority", (int&)lPriority);
	return TRUE;
}

BOOL CStoreQueue::GetQueueAgentPriority(LPCTSTR sQueueName, CString& sAgentName, LONG& lPriority)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sQueueName, +"\\", sAgentName);

	CStoreRegistry::GetINT(sKeyPath, "Priority", (int&)lPriority);
	return TRUE;
}

BOOL CStoreQueue::RemoveQueueAgentPriority(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG lPriority)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sQueueName, +"\\", sAgentName);

	CStoreRegistry::DeleteSubKey(sKeyPath);
	return TRUE;
}

BOOL CStoreQueue::SetQueueProcessMode(LPCTSTR sQueueName, int nProcessMode, int nProcessType)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);

	CStoreRegistry::SetINT(sKeyPath, "ProcessMode", nProcessMode);
	CStoreRegistry::SetINT(sKeyPath, "ProcessType", nProcessType);

	return TRUE;
}

BOOL CStoreQueue::GetQueueProcessMode(LPCTSTR sQueueName, int& nProcessMode, int& nProcessType)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sQueueName);

	CStoreRegistry::GetINT(sKeyPath, "ProcessMode", nProcessMode);
	CStoreRegistry::GetINT(sKeyPath, "ProcessType", nProcessType);
	return TRUE;
}

BOOL CStoreQueue::IsDataStored()
{
	return CStoreRegistry::IsKeyExist(ROOT_PATH);
}