#pragma once

class CVaxServerExCOM;
class CVaxCall;
class CVaxTransfer;
class CVaxQueue;
class CVaxRingGroup;
class CVaxHold;
class CVaxDTMF;
class CVaxRecordPCM;
class CVaxDialTone;
class CVaxDetectedAMD;
class CVaxThreadCallSession;

class CStealthListen;
class CCallParking;
class CCallPickUp;
class CVaxRoom;

class CVaxCallSession
{

public:

	CVaxCallSession(CVaxServerExCOM* pServerExCOM);
	~CVaxCallSession();

private:
	
	CString m_sRoomName;
	CVaxServerExCOM* m_pServerExCOM;
    
	CVaxRoom* m_pVaxRoom;
	CVaxCall* m_pVaxCall;
	CVaxTransfer* m_pVaxTransfer;
	
	CVaxQueue* m_pVaxQueue;
	CVaxRingGroup* m_pVaxRingGroup;
	
	CVaxHold* m_pVaxHold;
	CVaxDTMF* m_pVaxDTMF;
	CVaxRecordPCM* m_pVaxRecordPCM;
	
	CVaxDialTone* m_pVaxDialTone;
	CVaxDetectedAMD* m_pVaxDetectedAMD;

	CStealthListen* m_pStealthListen;
    CCallParking* m_pCallParking;
	CCallPickUp* m_pCallPickUp;

	BOOL m_bIsCallSessionAddedToRoom;
	
private:

	BOOL AcceptCallSession(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, int nToPeerType, LPCTSTR sToPeerName);
	
public:

	void OnIncomingCall(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName,  LONG lFromPeerType, LPCTSTR sFromPeerName, LONG lToPeerType, LPCTSTR sToPeerName, LPCTSTR sUserAgentName, LPCTSTR sFromIP, LONG lFromPort);
	void OnCallSessionConnected(LONG lSessionId);
	
	void OnCallSessionOnHold(LONG lSessionId, int nChannelId);
	void OnCallSessionOffHold(LONG lSessionId, int nChannelId);

	void OnCallSessionTransferBlind(LONG lTransfererSessionId, LONG lTransfererChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
	void OnCallSessionTransferConsult(LONG lTransfererSessionId, int nTransfererChannelId, LONG lTransferToSessionId, int nTransferToChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);

	void OnDetectedDigitDTMF(LONG lSessionId, int nChannelId, LPCTSTR sDigitDTMF);

	void OnCallSessionConnecting(LONG lSessionId, int nChannelId, LONG lStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionFailed(LONG lSessionId, int nChannelId, LONG lStatusCode, LPCTSTR sReasonPhrase);
	
	void OnCallSessionLost(LONG lSessionId, int nChannelId);
	void OnCallSessionHangup(LONG lSessionId, int nChannelId);
	void OnCallSessionTimeout(LONG lSessionId, int nChannelId);
	void OnCallSessionCancelled(LONG lSessionId);

	void OnCallSessionTransfering(LONG lSessionId, LONG lTransferType, int nChannelId, LONG lStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionTransferFailed(LONG lSessionId, LONG lTransferType, int nChannelId, LONG lStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionTransferTimeout(LONG lSessionId, LONG lTransferType, int nChannelId);
	void OnCallSessionTransfered(LONG lSessionId, LONG lTransferType);

	void OnCallSessionDialToneStart(LONG lSessionId, int nChannelId, LONG lWaveId);
	void OnCallSessionDialToneStop(LONG lSessionId, int nChannelId, LONG lWaveId);

	void OnCallSessionPlayWaveDone(LONG lSessionId, int nChannelId, LONG lWaveId);

	void OnCallSessionDetectedAMD(LONG lSessionId, int nChannelId, BOOL bIsHuman);
	void OnCallSessionRecordedPCM(LONG lSessionId, int nChannelId, char* pDataPCM, LONG lSizePCM);

	void OnAddCallSessionToQueueSuccess(LPCTSTR sQueueName, LONG lSessionId);
	void OnAddCallSessionToQueueFailed(LPCTSTR sQueueName, LONG lSessionId);

	void OnQueuePlayWaveStart(int nEventType, LPCTSTR sQueueName, LONG lSessionId);
	void OnQueuePlayWaveStop(int nEventType, LPCTSTR sQueueName, LONG lSessionId);

	void OnAddCallSessionToRingGroupSuccess(LONG lSessionId, LPCTSTR sRingGroupName);
	void OnAddCallSessionToRingGroupFailed(LONG lSessionId, LPCTSTR sRingGroupName);

};

