﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cVaxCallParking
    {
        public void OnIncomingCall(int nSessionId, string sDialNo, int nFromPeerType, ref bool bProcessed)
        {
            bProcessed = false;

            string sPrefixedDialNo = sDialNo;
            sPrefixedDialNo.Trim();

            if(sPrefixedDialNo.IndexOf("#3#") != 0)
                return;

            bProcessed = true;   

            sPrefixedDialNo = sPrefixedDialNo.Replace("#3#", "");
            sPrefixedDialNo = sPrefixedDialNo.Trim();

            int nSlotId;

            try
            {
                nSlotId = Convert.ToInt32(sPrefixedDialNo);
            }
            catch (Exception objEx)
            {
                return;
            }

            if(!cVaxServerExCOM.m_objVaxServerExCOM.ConnectToParkedCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, nSlotId))
            {
                int nErrorCode = cVaxServerExCOM.m_objVaxServerExCOM.GetVaxErrorCode();
                return;
            }

            StopMusicCallPark(nSessionId);
        }

        public void OnCallSessionTransferBlind(int nTransfererSessionId, int nTransfererChannelId, string sTransferer, string sTransferee, string sTransferTo, ref bool bProcessed)
        {
            bProcessed = false;

            int nChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ZERO;
            
            if(nTransfererChannelId == cVaxServerCOM.VAX_CALL_CHANNEL_ZERO)
                nChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ONE;

            string sPrefixedSlotId = sTransferTo;
            sPrefixedSlotId.Trim();

            if(sPrefixedSlotId.IndexOf("#2#") != 0)
                return;

            bProcessed = true;

            sPrefixedSlotId = sPrefixedSlotId.Replace("#2#", "");
            sPrefixedSlotId = sPrefixedSlotId.Trim();

            int nSlotId;
                
            try
            {
                nSlotId = Convert.ToInt32(sPrefixedSlotId);
            }
            catch (Exception objEx)
            {
                return;
            }

            if(!cVaxServerExCOM.m_objVaxServerExCOM.AcceptTransferBlind(nTransfererSessionId, sTransferee, sTransferee, "", -1, "", 30))
                return;

            if(!cVaxServerExCOM.m_objVaxServerExCOM.ParkCallSession(nTransfererSessionId, nChannelId, nSlotId))
                return;

            if(!StartMusicCallPark(nTransfererSessionId, nChannelId))
                return;
        }

        private bool StartMusicCallPark(int nSessionId, int nChannelId)
        {
            int nMusicId = cVaxServerExCOM.m_objVaxServerExCOM.GetMusicCallParking();

            if(nMusicId == -1)
                return false;

            return cVaxServerExCOM.m_objVaxServerExCOM.PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, true, 0);
        }

        private void StopMusicCallPark(int nSessionId)
        {
            int nMusicId = cVaxServerExCOM.m_objVaxServerExCOM.GetMusicCallParking();

            if(nMusicId == -1)
                return;

            cVaxServerExCOM.m_objVaxServerExCOM.PlayWaveStopToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, nMusicId);
            cVaxServerExCOM.m_objVaxServerExCOM.PlayWaveStopToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ONE, nMusicId);

        }
    }
}
