﻿
Imports System.Text

Public Class cVaxServerSIP : Inherits cVaxServerExCOM

    Public m_objErrorLogDlg As ErrorLogForm
    Public m_objStatusLogDlg As StatusLogForm

    Const HOLD_MUSIC_FILE = "..\\..\\..\\WaveFiles\\Hold.wav"
    Const DIAL_TONE_MUSIC_FILE = "..\\..\\..\\WaveFiles\\DialTone.wav"

    Public Sub New()
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function Initialize(ByVal sDomainRealm As String, ByVal sSIPListenIP As String, ByVal nSIPListenPort As Integer) As Boolean

        If (MyBase.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sSIPListenIP, -1) = False) Then
            Return False
        End If

        MyBase.SetListenPortRangeRTP(20000, 30000)

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        objStoreCOMM.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sSIPListenIP, -1)

        Return True

    End Function

    Public Function GetInitialize(ByRef sSIPListenIP As String, ByRef nSIPListenPort As Integer) As Boolean

        Dim sDomainRealm As String = ""
        Dim sRTPListenIP As String = ""
        Dim nRTPListenPort As Integer = -1

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        objStoreCOMM.GetInitialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort)

        Return True

    End Function

    Public Overloads Function LoadMusicHold(ByVal sFileName As String) As Boolean

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        objStoreCOMM.SetMusicHold(sFileName)

        Return MyBase.LoadMusicHold(sFileName)

    End Function

    Public Function GetMusicHold() As String

        Dim sFileName As String = ""
        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()

        If (objStoreCOMM.GetMusicHold(sFileName) = False) Then
            sFileName = HOLD_MUSIC_FILE
        End If

        Return sFileName

    End Function

    Public Overloads Function LoadMusicDialTone(ByVal sFileName As String) As Boolean

        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()
        objStoreCOMM.SetMusicDialTone(sFileName)

        Return MyBase.LoadMusicDialTone(sFileName)

    End Function

    Public Function GetMusicDialTone() As String

        Dim sFileName As String = ""
        Dim objStoreCOMM As cStoreCOMM = New cStoreCOMM()

        If (objStoreCOMM.GetMusicDialTone(sFileName) = False) Then
            sFileName = DIAL_TONE_MUSIC_FILE
        End If

        Return sFileName

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddUser(ByVal sLogin As String, ByVal sPassword As String, ByVal sCodecList As String, ByVal bBlocked As Boolean, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean

        If (IsInitialized() = False) Then
            Return False
        End If

        If (sLogin.Length = 0) Then
            Return False
        End If

        RemoveUser(sLogin)

        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.AddUser(sLogin, sPassword, sCodecList, bBlocked)

        If (sUserPrefix.Length <> 0 Or sDialPrefix.Length <> 0) Then
            objStoreUser.AddUserRoute(sLogin, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
            MyBase.AddUserRoute(sLogin, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
        End If

        Return MyBase.AddUser(sLogin, sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)

    End Function

    Public Overloads Sub RemoveUser(ByVal sLogin As String)

        If (IsInitialized() = False) Then
            Return
        End If

        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.RemoveUser(sLogin)

        MyBase.RemoveUser(sLogin)
        MyBase.RemoveUserRoute(sLogin)

    End Sub

    Public Sub GetUserNameAll(ByRef objList As ArrayList)

        Dim objListUser As List(Of String) = New List(Of String)

        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.GetUserNameAll(objListUser)

        objList.AddRange(objListUser)

    End Sub

    Public Function GetUserDetails(ByVal sUserName As String, ByRef sPassword As String, ByRef sCodecList As String, ByRef bBlocked As Boolean, ByRef sUserPrefix As String, ByRef sDialPrefix As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String) As Boolean

        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.GetUser(sUserName, sPassword, sCodecList, bBlocked)
        objStoreUser.GetUserRoute(sUserName, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)

        Return True

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddLine(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxySIP As String, ByVal sCodecList As String, ByVal bRegister As Boolean, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String) As Boolean

        If (IsInitialized() = False) Then
            Return False
        End If

        RemoveLine(sLineName)

        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, "", sCodecList, bRegister)
        objStoreLine.AddLineRoute(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName)

        MyBase.AddLineRoute(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName)
        Return MyBase.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bRejected, sRoomName)

    End Function

    Public Overloads Sub RemoveLine(ByVal sLineName As String)

        If (IsInitialized() = False) Then
            Return
        End If

        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.RemoveLineRoute(sLineName)
        objStoreLine.RemoveLine(sLineName)

        MyBase.RemoveLineRoute(sLineName)
        MyBase.RemoveLine(sLineName)

    End Sub

    Public Sub GetLineAll(ByRef arrLineList As ArrayList)

        Dim objListLine As List(Of String) = New List(Of String)

        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.GetLineNameAll(objListLine)

        arrLineList.AddRange(objListLine)

    End Sub

    Public Function GetLineDetails(ByVal sLineName As String, ByRef sDisplayName As String, ByRef sUserName As String, ByRef sAuthUser As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sProxySIP As String, ByRef sCodecList As String, ByRef bRegister As Boolean, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String) As Boolean

        If (IsInitialized() = False) Then
            Return False
        End If

        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.GetLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, "", sCodecList, bRegister)
        objStoreLine.GetLineRoute(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName)

        Return True

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddDirectProxySIP(ByVal sProxyName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxyIP As String, ByVal nProxyPort As Integer, ByVal sCodecList As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String) As Boolean

        If (IsInitialized() = False) Then
            Return False
        End If

        RemoveDirectProxySIP(sProxyName)

        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()

        objStoreProxy.AddDirectProxySIP(sProxyName, sAuthLogin, "", sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)
        objStoreProxy.AddDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bRejected, sRoomName)

        MyBase.AddDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bRejected, sRoomName)
        Return MyBase.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bRejected, sRoomName)

    End Function

    Public Overloads Sub RemoveDirectProxySIP(ByVal sProxyName As String)

        If (IsInitialized() = False) Then
            Return
        End If

        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()
        objStoreProxy.RemoveDirectProxySIP(sProxyName)

        MyBase.RemoveDirectProxyRoute(sProxyName)
        MyBase.RemoveDirectProxySIP(sProxyName)

    End Sub


    Public Sub GetDirectProxyAll(ByRef arrProxyList As ArrayList)

        Dim objListProxy As List(Of String) = New List(Of String)

        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()
        objStoreProxy.GetDirectProxySIPAll(objListProxy)

        arrProxyList.AddRange(objListProxy)
    End Sub

    Public Function GetDirectProxyDetails(ByVal sProxyName As String, ByRef sAuthLogin As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sProxyIP As String, ByRef nProxyPort As Integer, ByRef sCodecList As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String) As Boolean

        If (IsInitialized() = False) Then
            Return False
        End If

        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()
        objStoreProxy.GetDirectProxySIP(sProxyName, sAuthLogin, "", sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)
        objStoreProxy.GetDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bRejected, sRoomName)

        Return True
    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddRoom(ByVal sRoomName As String, ByVal sRoomNo As String) As Boolean

        If (MyBase.IsInitialized() = False) Then
            Return False
        End If

        RemoveRoom(sRoomName)

        If (MyBase.AddRoom(sRoomName, sRoomNo) = False) Then
            Return False
        End If

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.AddRoom(sRoomName, sRoomNo)

        Return True

    End Function

    Public Overloads Sub RemoveRoom(ByVal sRoomName As String)

        If (IsInitialized() = False) Then
            Return
        End If

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.RemoveRoom(sRoomName)

        MyBase.RemoveRoom(sRoomName)

    End Sub

    Public Function GetRoomDetails(ByVal sRoomName As String, ByRef sRoomNo As String) As Boolean

        If (IsInitialized() = False) Then
            Return False
        End If

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.GetRoom(sRoomName, sRoomNo)

        Return True

    End Function

    Public Function GetRoomAll(ByRef arrRoomName As ArrayList) As Boolean

        If (IsInitialized() = False) Then
            Return False
        End If

        Dim objListRoom As List(Of String) = New List(Of String)

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.GetRoomAll(objListRoom)

        If (objListRoom.Count > 0) Then
            arrRoomName.AddRange(objListRoom)
        End If

        Return True

    End Function

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub LoadUser()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListUsers As List(Of String) = New List(Of String)
        Dim objStoreUser As cStoreUser = New cStoreUser()
        objStoreUser.GetUserNameAll(objListUsers)

        If (objListUsers.Count = 0) Then
            Return
        End If

        Dim sPassword As String = ""
        Dim sCodecList As String = ""
        Dim sUserPrefix As String = ""
        Dim sDialPrefix As String = ""
        Dim sToPeerName As String = ""

        Dim bBlocked As Boolean = False
        Dim nToPeerType As Integer = -1

        For Each sUserName As String In objListUsers

            objStoreUser.GetUser(sUserName, sPassword, sCodecList, bBlocked)
            objStoreUser.GetUserRoute(sUserName, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)

            If (sUserPrefix.Length <> 0 Or sDialPrefix.Length <> 0) Then
                MyBase.AddUserRoute(sUserName, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
            End If

            MyBase.AddUser(sUserName, sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)

        Next
    End Sub

    Private Sub LoadLine()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListLines As List(Of String) = New List(Of String)
        Dim objStoreLine As cStoreLine = New cStoreLine()
        objStoreLine.GetLineNameAll(objListLines)

        If (objListLines.Count = 0) Then
            Return
        End If

        Dim sDisplayName As String = ""
        Dim sUserName As String = ""
        Dim sAuthUser As String = ""
        Dim sAuthPwd As String = ""
        Dim sDomainRealm As String = ""
        Dim sProxySIP As String = ""
        Dim sCodecList As String = ""
        Dim sOutboundProxySIP As String = ""
        Dim sToPeerName As String = ""
        Dim sRoomName As String = ""

        Dim bRegister As Boolean = False
        Dim bRejected As Boolean = False

        Dim nToPeerType As Integer = -1

        For Each sLineName As String In objListLines

            objStoreLine.GetLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList, bRegister)
            objStoreLine.GetLineRoute(sUserName, nToPeerType, sToPeerName, bRejected, sRoomName)

            MyBase.AddLineRoute(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName)
            MyBase.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bRejected, sRoomName)

        Next
    End Sub

    Private Sub LoadDirectProxy()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListProxy As List(Of String) = New List(Of String)
        Dim objStoreProxy As cStoreDirectProxy = New cStoreDirectProxy()
        objStoreProxy.GetDirectProxySIPAll(objListProxy)

        If (objListProxy.Count = 0) Then
            Return
        End If

        Dim sAuthLogin As String = ""
        Dim sUserName As String = ""
        Dim sAuthPwd As String = ""
        Dim sDomainRealm As String = ""
        Dim sProxyIP As String = ""
        Dim sCodecList As String = ""
        Dim sToPeerName As String = ""
        Dim sRoomName As String = ""
        Dim sOutboundProxySIP As String = ""

        Dim bCallRejected As Boolean = False

        Dim nProxyPort As Integer = -1
        Dim nToPeerType As Integer = -1

        For Each sProxy As String In objListProxy

            objStoreProxy.GetDirectProxySIP(sProxy, sAuthLogin, sUserName, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)
            objStoreProxy.GetDirectProxyRoute(sProxy, nToPeerType, sToPeerName, bCallRejected, sRoomName)

            MyBase.AddDirectProxyRoute(sProxy, nToPeerType, sToPeerName, bCallRejected, sRoomName)
            MyBase.AddDirectProxySIP(sProxy, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bCallRejected, sRoomName)

        Next
    End Sub

    Private Sub LoadConfRoom()

        If (MyBase.IsInitialized() = False) Then
            Return
        End If

        Dim objListRoom As List(Of String) = New List(Of String)
        Dim objStoreRoom As cStoreRoom = New cStoreRoom()
        objStoreRoom.GetRoomAll(objListRoom)

        If (objListRoom.Count = 0) Then
            Return
        End If

        Dim sRoomNo As String = ""
        For Each sRoomName As String In objListRoom

            objStoreRoom.GetRoom(sRoomName, sRoomNo)
            MyBase.AddRoom(sRoomName, sRoomNo)

        Next
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Function LoadUserDefault() As Boolean

        Dim objStoreUser As cStoreUser = New cStoreUser()

        If (objStoreUser.IsDataStored() = True) Then
            Return False
        End If

        For nCount = 4040 To 4050
            Me.AddUser(nCount.ToString(), nCount.ToString(), "32014", False, "", "", cVaxServerCOM.VAX_PEER_TYPE_USER, "")
        Next

        Return True

    End Function

    Public Overrides Sub OnInitialize()

        If (LoadUserDefault() = False) Then
            LoadUser()
        End If

        LoadLine()
        LoadDirectProxy()
        LoadConfRoom()

    End Sub

    Public Overrides Sub OnErrorLog(ByVal sMsg As String)
        m_objErrorLogDlg.OnErrorLog(sMsg)
    End Sub

    Public Overrides Sub OnStatusLog(ByVal sMsg As String)
        m_objStatusLogDlg.OnStatusLog(sMsg)
    End Sub

End Class
